<?php
namespace moonlight\mmapi;

class sgdcintranet_mysql extends \moonlight\db_mysql{
	
//******************************************************Profile Picture Start******************************************************//
 /*
   * Function to get album detail
   */
   public function get_profile_album($p_value){
		$v_query = "SELECT 
					album_id
					FROM " . $this->get_db_table_prefix() . "album 
					WHERE album_title = \"Profile Picture\"
					AND album_user = \"".\U::safe_sql_string($p_value)."\"
					";
		$v_result = parent::execute_query($v_query);
		return $v_result[0]['album_id'];
   }
    /*
   * Function to add album
   */
  public function album_add( $p_value ){
		
    $v_query = 	"INSERT INTO 
                    " . $this->get_db_table_prefix() . "album(
                      album_user,
                      album_publish,
                      album_sequence,
                      album_title,
                      album_desc,
                      _rec_created_on,
                      _rec_created_by,
                      _rec_modified_on,
                      _rec_modified_by,
                      _rec_status
                  )VALUE(
                      \"" . \U::safe_sql_string( $p_value['album_user'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['album_publish'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['album_sequence'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['album_title'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['album_desc'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\"
                  )";
    $v_result = parent::execute_query($v_query);
    $v_id =  parent::get_last_insert_id();
	if(!empty($v_id)){
		$v_cond = "";
		$v_query = 	"INSERT INTO 
                    " . $this->get_db_table_prefix() . "album_group(
                      album_id,
                      album_group_access,
                      _rec_created_on,
                      _rec_created_by,
                      _rec_modified_on,
                      _rec_modified_by
					)VALUE(
					\"" . \U::safe_sql_string( $v_id ) . "\",
					\"" . \U::safe_sql_string( "everyone" ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
					)";
		// print $v_query;
		$v_result = parent::execute_query($v_query);
	}
	return $v_id;
  }
   
   /*
   * Function to add photo
   */
  public function photo_add_profile_pic( $p_value ){
    $v_query = 	"INSERT INTO 
                    " . $this->get_db_table_prefix() . "photo(
                      album_id,
                      photo_publish,
                      photo_sequence,
                      photo_desc,
                      photo_file_name,
                      photo_file_size,
                      photo_file_type,
                      _rec_created_on,
                      _rec_created_by,
                      _rec_modified_on,
                      _rec_modified_by,
                      _rec_status
                  )VALUE(
                      \"" . \U::safe_sql_string( $p_value['album_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['photo_publish'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['photo_sequence'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['photo_desc'] ) . "\",
											
                      \"" . \U::safe_sql_string( $p_value['profile_img']['name'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['profile_img']['size'] ) . "\",
					  \"" . \U::safe_sql_string( $p_value['profile_img']['type'] ) . "\",
											
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\"
                  )";
    $v_result = parent::execute_query($v_query);
    return parent::get_last_insert_id();
  }
  
   /*
	* Update user preference picture. 
	* Use INSERT...ON DUPLICATE KEY UPDATE to ensure success, because user may or may not have record in table
	*/
	public function photo_update_profile_pic($p_value){
		$v_query = 	"INSERT INTO " . $this->get_db_table_prefix() . "user_pref(
									usr_id,
									pic_id,
									_rec_created_on,
									_rec_created_by,
									_rec_modified_on,
									_rec_modified_by
									)VALUES(
									\"" . \U::safe_sql_string( $p_value['user_id'] ) . "\",
									\"" . \U::safe_sql_string( $p_value['profile_pic'] ) . "\",
									\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
									\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
									\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
									\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
									) ON DUPLICATE KEY UPDATE
                      pic_id = \"" . \U::safe_sql_string( $p_value['profile_pic'] ) . "\",
                      _rec_modified_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      _rec_modified_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
                ";
								// print $v_query;
    $v_result = parent::execute_query($v_query);
	}
	
	/*
	*	Calculate total pictures size which a user has uploaded.
	* For quota limit purpose.
	*/
	public function photo_get_all_size($p_usr_id){
		$v_query = "SELECT SUM(p.photo_file_size)as total_size 
								FROM " . $this->get_db_table_prefix() . "photo p 
								LEFT JOIN " . $this->get_db_table_prefix() . "album a ON a.album_id=p.album_id
								WHERE a.album_user=\"" . \U::safe_sql_string( $p_usr_id ) . "\" 
								AND p._rec_status = \"SHOW\"
								GROUP BY a.album_user";
		$v_result = parent::execute_query($v_query);
		return $v_result[0]['total_size'];
	}
	
//******************************************************Profile Picture End******************************************************//
//******************************************************Staff Start******************************************************//
	public function get_staff_profile( $p_value){
		
		// QUERY - Coding
		$v_query = 	"SELECT 
                    update_status
                  FROM " . $this->get_db_table_prefix() . "acl_user_group 
				  WHERE usr_id = \"".\U::safe_sql_string($p_value['id'])."\" 
				  ";

		$vResult = parent::execute_query($v_query);
		
		return $vResult;
	}
	
	/*
	* Get user preference using user id
	*/
	public function user_get_pref($p_user_id=null){
		$v_cond='';
		if(!empty($p_user_id)){
			if(is_array($p_user_id['id'])){
				foreach($p_user_id['id'] as $v_each){
					$v_ary_usr[]= \U::safe_sql_string($v_each);
				}
				$v_cond .=" AND usr_id IN (".implode(",",$v_ary_usr).") ";
			}else{
				$v_cond .=" AND usr_id=\"" . \U::safe_sql_string( $p_user_id['id'] ) . "\" ";
			}
		}else{
			return false;
		}
		$v_query="SELECT 
							usr_id,
							pic_id,
							_rec_status,
							_rec_created_on,
							_rec_created_by,
							_rec_modified_on,
							_rec_modified_by 
							FROM " . $this->get_db_table_prefix() . "user_pref
							WHERE _rec_status=\"SHOW\"
							".$v_cond."
							";
							// print $v_query;
		$v_result = parent::execute_query($v_query);
		return $v_result;
	}
	
	public function set_staff_update_status( $p_value){
		
		// QUERY - Coding
		$v_query = 	"UPDATE " . $this->get_db_table_prefix() . "acl_user_group SET 
                    update_status = \"1\"
				  WHERE usr_id = \"".\U::safe_sql_string($p_value['id'])."\" 
				  ";

		$vResult = parent::execute_query($v_query);
		
		// return $vResult;
	}
	
	public function add_staff_to_intranet( $p_value){
		// QUERY - Coding
		$v_query = "REPLACE INTO ". $this->get_db_table_prefix() . "acl_user_group SET 
					usr_id = \"".\U::safe_sql_string($p_value['id'])."\" ,
					group_id = \"".\U::safe_sql_string($p_value['usr_group'])."\" ,
					update_status = \"0\",
					_rec_status = \"SHOW\",
					_rec_created_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
					_rec_created_by = \"".\U::safe_sql_string($p_value['current_usr_id'])."\",
					_rec_modified_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
					_rec_modified_by = \"".\U::safe_sql_string($p_value['current_usr_id'])."\"
					";
		$v_result = parent::execute_query($v_query);

		// update agency to maintain
		if(!empty($p_value['usr_agency'])){
			$v_temp=explode(",",$p_value['usr_agency']);
			if(is_array($v_temp)){
				foreach($v_temp as $v_each_agency){
					$v_ins_ary[]= " (
					\"" . \U::safe_sql_string( $p_value['id'] ) . "\",
					\"" . \U::safe_sql_string( $v_each_agency ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
					) 
					";
					$v_ary_id[]=\U::safe_sql_string( $v_each_agency );
				}
				$v_ins_val=implode(",",$v_ins_ary);
				$v_id_val=implode(",",$v_ary_id);
			}
			
			$v_query="UPDATE " . $this->get_db_table_prefix() . "acl_agency 
								SET
								_rec_status=\"DELETED\",
								_rec_deleted_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
								_rec_deleted_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
								WHERE usr_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
								AND NOT agency_id IN (".\U::safe_sql_string( $v_id_val ).")
							";
			$v_result = parent::execute_query($v_query);
			if($v_result){
				$v_query="INSERT INTO " . $this->get_db_table_prefix() . "acl_agency 
				(usr_id,agency_id,_rec_created_on,_rec_created_by,_rec_modified_on,_rec_modified_by)
				VALUES
				".$v_ins_val."
				ON DUPLICATE KEY UPDATE 
				_rec_status=\"SHOW\",
				_rec_modified_on=\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
				_rec_modified_by=\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
				";
				$v_result = parent::execute_query($v_query);
			}
			return $v_result;
		}
		// end update agency to maintain
	}

	public function update_staff_to_intranet( $p_value){
		// QUERY - Coding
		$v_query = 	"UPDATE 
                    " . $this->get_db_table_prefix() . "acl_user_group 
                  SET
                    group_id = \"" . \U::safe_sql_string( $p_value['usr_group'] ) . "\", 
                    _rec_modified_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                    _rec_modified_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
                  WHERE 
                    usr_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
                ";
		$v_result = parent::execute_query($v_query);
		// update agency to maintain
		if(!empty($p_value['usr_agency'])){
			$v_temp=explode(",",$p_value['usr_agency']);
			if(is_array($v_temp)){
				foreach($v_temp as $v_each_agency){
					$v_ins_ary[]= " (
					\"" . \U::safe_sql_string( $p_value['id'] ) . "\",
					\"" . \U::safe_sql_string( $v_each_agency ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
					\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
					) 
					";
					$v_ary_id[]=\U::safe_sql_string( $v_each_agency );
				}
				$v_ins_val=implode(",",$v_ins_ary);
				$v_id_val=implode(",",$v_ary_id);
			}
			
			$v_query="UPDATE " . $this->get_db_table_prefix() . "acl_agency 
								SET
								_rec_status=\"DELETED\",
								_rec_deleted_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
								_rec_deleted_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
								WHERE usr_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
								AND NOT agency_id IN (".\U::safe_sql_string( $v_id_val ).")
							";
			$v_result = parent::execute_query($v_query);
			if($v_result){
				$v_query="INSERT INTO " . $this->get_db_table_prefix() . "acl_agency 
				(usr_id,agency_id,_rec_created_on,_rec_created_by,_rec_modified_on,_rec_modified_by)
				VALUES
				".$v_ins_val."
				ON DUPLICATE KEY UPDATE 
				_rec_status=\"SHOW\",
				_rec_modified_on=\"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
				_rec_modified_by=\"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
				";
				$v_result = parent::execute_query($v_query);
			}
			return $v_result;
		}
		// end update agency to maintain
	}
	
	public function soft_del_staff_in_intranet( $p_value){

    $v_query = 	"UPDATE 
                    " . $this->get_db_table_prefix() . "acl_user_group 
                  SET
                      _rec_deleted_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      _rec_deleted_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      _rec_status = \"DELETED\"
                  WHERE 
                      usr_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
                ";
    $v_result = parent::execute_query($v_query);
		if($v_result){
			$v_query="UPDATE " . $this->get_db_table_prefix() . "acl_agency 
									SET
									_rec_status=\"DELETED\",
									_rec_deleted_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
									_rec_deleted_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
									WHERE usr_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
								";
			$v_result = parent::execute_query($v_query);
		}
    if($v_result){
      return true;
    }else{
      return false;
    }
		
  }
  
  public function hard_del_staff_in_intranet( $p_value){

    $v_query = 	"DELETE FROM 
                    " . $this->get_db_table_prefix() . "acl_user_group 
                  WHERE 
                      usr_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
                ";
    $v_result = parent::execute_query($v_query);

    if($v_result){
      return true;
    }else{
      return false;
    }
  }
  
  
  /*
   * Function to retrieve the list of user
   */
  public function user_acl_list( $p_order=null, $p_start = null, $p_num_of_rec = null, $p_value = null ){
    // Default Language
    $v_lang_info = \E::get('obj_curr_module')->get_lang();

    $v_cond = '';
		//publish status, mainly for frontend.
		if(!empty($p_value['_rec_status'])){
			$v_cond .=" AND u._rec_status=\"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\" ";
		}

    //group filter
		if(!empty($p_value['group'])){
			$v_cond .=" AND u.group_id=\"" . \U::safe_sql_string( $p_value['group'] ) . "\" ";
		}

    //user filter
		if(!empty($p_value['search'])){
			$v_cond .=" AND u.usr_id IN (\"" . implode('","', $p_value['search']) . "\") ";
		}

		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', ' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
			
		}
		
		// QUERY - Coding
		$v_query = 	"SELECT 
					usr_id,
					kwd_value,
                    u._rec_modified_on
                  FROM " . $this->get_db_table_prefix() . "acl_user_group u
                  LEFT JOIN " . $this->get_db_table_prefix() . "acl_group_lbl l
                  ON u.group_id = l.kwd_code AND l.kwd_lang=\"".$v_lang_info."\"
                  WHERE u._rec_status = \"SHOW\"
                  {$v_cond}
                  " . $v_order_by . $v_limit;
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			foreach($v_result as $v_key=>$v_value){
        $v_result[$v_key]['_rec_modified_on'] = parent::__to_display_date($v_result[$v_key]['_rec_modified_on']);
      }
    }

    return $v_result;
  }

  /*
   * Function to count the total of articles
   */
  public function user_acl_list_total( $p_value ){
    
	// Default Language
    $v_lang_info = \E::get('obj_curr_module')->get_lang();

    $v_cond = '';
		//publish status, mainly for frontend.
		if(!empty($p_value['_rec_status'])){
			$v_cond .=" AND u._rec_status=\"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\" ";
		}

    //group filter
		if(!empty($p_value['group'])){
			$v_cond .=" AND u.group_id=\"" . \U::safe_sql_string( $p_value['group'] ) . "\" ";
		}

    //user filter
		if(!empty($p_value['search'])){
			$v_cond .=" AND u.usr_id IN (\"" . implode('","', $p_value['search']) . "\") ";
		}
		/*
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', ' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}
		
		// LIMIT - Coding
		 $v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
		} */
		
		// QUERY - Coding
		$v_query = 	"SELECT 
					COUNT(usr_id) as 'total_rec'
                  FROM " . $this->get_db_table_prefix() . "acl_user_group u
                  LEFT JOIN " . $this->get_db_table_prefix() . "acl_group_lbl l
                  ON u.group_id = l.kwd_code AND l.kwd_lang=\"".$v_lang_info."\"
                  WHERE u._rec_status = \"SHOW\"
                  {$v_cond}
                  ";
    $v_result = parent::execute_query($v_query);
			
    return $v_result[0]['total_rec'];

    // return $v_result;
  }
  
  /*
   * Function to retrieve the list of group
   */
  public function user_group_list( $p_order=null, $p_start = null, $p_num_of_rec = null ){
    // Default Language
    $v_lang_info = \E::get('obj_curr_module')->get_lang();

		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY '.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', ' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
			
		}
		
		// QUERY - Coding
		$v_query = 	"SELECT 
										l.kwd_code,
										kwd_value,
                    g._rec_modified_on
                  FROM " . $this->get_db_table_prefix() . "acl_group_lbl l
                  LEFT JOIN " . $this->get_db_table_prefix() . "acl_group g
                  ON g.group_id = l.kwd_code
                  WHERE g._rec_status = \"SHOW\"
                  AND l.kwd_lang=\"".$v_lang_info."\" " . $v_order_by . $v_limit;
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			foreach($v_result as $v_key=>$v_value){
        $v_result[$v_key]['_rec_modified_on'] = parent::__to_display_date($v_result[$v_key]['_rec_modified_on']);
      }
    }

    return $v_result;
  }

  /*
   * Function to count the total of articles
   */
  public function user_group_list_total(){
    // Default Language
    $v_lang_info = \E::get('obj_curr_module')->get_lang();
		
    // QUERY - Coding
		$v_query = 	"SELECT 
                    COUNT(kwd_code) AS 'total_rec'
                  FROM " . $this->get_db_table_prefix() . "acl_group_lbl l
                  LEFT JOIN " . $this->get_db_table_prefix() . "acl_group g
                  ON g.group_id = l.kwd_code
                  WHERE g._rec_status = \"SHOW\"
                  AND l.kwd_lang=\"".$v_lang_info."\" ";					

    $v_result = parent::execute_query($v_query);
			
    return $v_result[0]['total_rec'];
  }
  
  public function user_acl_get( $p_id ){
    // Default Language
    $v_lang_info = \E::get('obj_curr_module')->get_lang();
    
    // QUERY - acl group table
    
		$v_query = 	"SELECT 
                    ug.usr_id,
										ug.group_id,
										ug.update_status,
										GROUP_CONCAT(ua.agency_id) as agency_maintain,
										ug._rec_modified_on
                  FROM " . $this->get_db_table_prefix() . "acl_user_group ug
									LEFT JOIN " . $this->get_db_table_prefix() . "acl_agency ua
									ON ug.usr_id=ua.usr_id AND ua._rec_status=\"SHOW\"
                  WHERE 
									ug._rec_status = \"SHOW\" 
                  AND ug.usr_id=\"" . \U::safe_sql_string( $p_id ) . "\"
									GROUP BY ug.usr_id
                ";
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
      // $v_result[$v_key]['_rec_modified_on'] = parent::__to_display_date($v_result[$v_key]['_rec_modified_on']);
      $v_result[0]['_rec_modified_on'] = parent::__to_display_date($v_result[0]['_rec_modified_on']);
    }

    return $v_result;
  }
  
  public function user_group_get( $p_id ){
    // Default Language
    $v_lang_info = \E::get('obj_curr_module')->get_lang();
    
    // QUERY - acl group table
    
		$v_query = 	"SELECT 
                    *
                  FROM " . $this->get_db_table_prefix() . "acl_group 
                  WHERE _rec_status = \"SHOW\" 
                  AND group_id=\"" . \U::safe_sql_string( $p_id ) . "\"
                ";
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			foreach($v_result as $v_key=>$v_value){
        $v_result[$v_key]['_rec_modified_on'] = parent::__to_display_date($v_result[$v_key]['_rec_modified_on']);
      }
    }
    

		// QUERY - label table
		$v_query = 	"SELECT 
                    kwd_lang,
                    kwd_value
                  FROM " . $this->get_db_table_prefix() . "acl_group_lbl l
                  LEFT JOIN " . $this->get_db_table_prefix() . "acl_group g
                  ON g.group_id = l.kwd_code
                  WHERE g._rec_status = \"SHOW\" 
                  AND g.group_id=\"" . \U::safe_sql_string( $p_id ) . "\"
                ";
		$v_result_lbl = parent::execute_query($v_query);
    //print_r($v_result_lbl);
		if($v_result_lbl && is_array($v_result_lbl)){
			foreach($v_result_lbl as $v_value){
        $v_result[0]['kwd_value'][$v_value['kwd_lang']] = $v_value['kwd_value'];
      }
    }

    return $v_result;
  }

  public function log_agency( $p_value){
		
		// QUERY - Coding
		$v_query = 	"INSERT INTO 
                    " . $this->get_db_table_prefix() . "agency_log(
					  usr_id,
                      usr_full_name,
                      ag_id_ori,
                      ag_id_new,
                      _rec_created_on,
                      _rec_created_by,
                      _rec_modified_on,
                      _rec_modified_by
                  )VALUE(
				      \"" . \U::safe_sql_string( $p_value['usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['usr_full_name'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['ag_id_ori'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['ag_id_new'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
                  )";
		$vResult = parent::execute_query($v_query);
		
		// return $vResult;
  }

//******************************************************Staff End******************************************************//
//******************************************************Market Start******************************************************//
	public function get_market_all(){

		$vQuery = "SELECT 
					a.market_image_id,
					a.parent_id,
					a.market_image_type,
					a.market_image_size,
					a.market_image_name,
					b.usr_id,
					b.market_id,
					b.market_heading,
					b.market_description,
					b.market_category,
					b.market_location,
					b.market_price,
					b.market_status,
					b.market_show_status,
					b.last_modified_on,
					b._rec_modified_on,
					b._rec_status
					FROM ".$this->get_db_table_prefix()."market b
					left outer join ".$this->get_db_table_prefix()."market_image a on b.market_id = a.parent_id
					WHERE b._rec_status = \"SHOW\"
						AND b.market_show_status = \"Activate\"
					GROUP BY a.parent_id ORDER BY b.last_modified_on DESC";	
		$vResult = parent::execute_query($vQuery);
		if($vResult && is_array($vResult)){
			foreach($vResult as $v_key=>$v_value){
				$vResult[$v_key]['last_modified_on'] = parent::__to_display_date($vResult[$v_key]['last_modified_on']);
				$vResult[$v_key]['_rec_modified_on'] = parent::__to_display_date($vResult[$v_key]['_rec_modified_on']);
			}
		}
		return $vResult;
	} 
	
	public function get_market($id){
		
		$vQuery = "SELECT * FROM ".$this->get_db_table_prefix()."market WHERE market_id=\"".\U::safe_sql_string($id)."\" ";	
		$vResult = parent::execute_query($vQuery);
		if($vResult && is_array($vResult)){
			foreach($vResult as $v_key=>$v_value){
				$vResult[$v_key]['_rec_modified_on'] = parent::__to_display_date($vResult[$v_key]['_rec_modified_on']);
				$vResult[$v_key]['_rec_modified_on_system_date'] = parent::__to_system_date($vResult[$v_key]['_rec_modified_on'],"DATE");
			}
		}
		return $vResult;
	} 
	
	public function get_market_image($id){
		
		$vQuery = "SELECT * FROM ".$this->get_db_table_prefix()."market_image WHERE parent_id=\"".\U::safe_sql_string($id)."\" ";	
		$vResult = parent::execute_query($vQuery);
		return $vResult;
	} 
	
	public function get_market_image_total($id){
		
		$vQuery = "SELECT count(market_image_id) as totalRow FROM ".$this->get_db_table_prefix()."market_image WHERE parent_id=\"".\U::safe_sql_string($id)."\" ";	
		$vResult = parent::execute_query($vQuery);
		return $vResult[0]['totalRow'];
	} 
	
	
	public function market_list_search( $p_order=null, $p_start = null, $p_num_of_rec = null , $p_search_keyword ,$p_search_category=null, $p_search_location=null ){
		
		// ORDER BY - Coding
		// $v_order_by = '';
		// if($p_order != null){
			// foreach($p_order as $v_value){
				// if($v_order_by == '') $v_order_by = " ORDER BY ".\U::safe_sql_string($v_value['order_by'])." ".\U::safe_sql_string($v_value['sort_by']);
				// else $v_order_by .= ", " . \U::safe_sql_string($v_value['order_by']) . " " .\U::safe_sql_string($v_value['sort_by']);
			// }
		// }
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = " LIMIT " . \U::safe_sql_string($p_start) . ", " . \U::safe_sql_string($p_num_of_rec);
			
		}
		// SEARCH - Coding
		$v_search = '';

		if($p_search_keyword != null){
				if($v_search == '') $v_search = " AND (market_heading LIKE '%".\U::safe_sql_string($p_search_keyword)."%' OR market_description LIKE '%".\U::safe_sql_string($p_search_keyword)."%') ";
		}
		if($p_search_category != null){
				if($v_search == '') {$v_search = " AND market_category = '".\U::safe_sql_string($p_search_category)."' ";}
				else{$v_search .= " AND market_category = '".\U::safe_sql_string($p_search_category)."' ";}
		}
		if($p_search_location != null){
				if($v_search == '') {$v_search = " AND market_location = '".\U::safe_sql_string($p_search_location)."' ";}
				else{$v_search .= " AND market_location = '".\U::safe_sql_string($p_search_location)."' ";}
		}
		
		// QUERY - Coding
		$vQuery = 	"SELECT 
					usr_id,
                    market_id,
                    market_heading,
					market_location,
					market_description,
					market_category,
					market_price,
					market_status,
					last_modified_on,
                    _rec_modified_on,
					'' AS market_image_id,
					'' AS market_image_type,
					'' AS market_image_size,
					'' AS market_image_name
                  FROM " . $this->get_db_table_prefix() . "market 
                  WHERE _rec_status = \"SHOW\"
				  AND market_show_status = \"Activate\"
                  " .$v_search. " ORDER BY last_modified_on DESC " . $v_limit;

		$vResult = parent::execute_query($vQuery);
		if($vResult && is_array($vResult)){
			foreach($vResult as $v_key=>$v_value){
				$vStrImageId ="";
				$vStrImageType ="";
				$vStrImageSize ="";
				$vStrImageName ="";
				
				$vQueryImage = "SELECT 
							parent_id,
							market_image_id,
							market_image_type,
							market_image_size,
							market_image_name
						  FROM " . $this->get_db_table_prefix() . "market_image
						  WHERE parent_id = ".$vResult[$v_key]['market_id']."
						  ORDER BY market_image_id
						  LIMIT 0,4
						";
				$vResultImage = parent::execute_query($vQueryImage);
				if($vResultImage && is_array($vResultImage)){
					foreach($vResultImage as $v_key_image=>$v_value_image){
						if(empty($vStrImageId) && $vStrImageId ==""){
							$vStrImageId = $vResultImage[$v_key_image]['market_image_id'];
						}else{
							$vStrImageId .= ",".$vResultImage[$v_key_image]['market_image_id']; 
						}
						if(empty($vStrImageType) && $vStrImageType ==""){
							$vStrImageType = $vResultImage[$v_key_image]['market_image_type'];
						}else{
							$vStrImageType .= ",".$vResultImage[$v_key_image]['market_image_type']; 
						}
						if(empty($vStrImageSize) && $vStrImageSize ==""){
							$vStrImageSize = $vResultImage[$v_key_image]['market_image_size'];
						}else{
							$vStrImageSize .= ",".$vResultImage[$v_key_image]['market_image_size']; 
						}
						if(empty($vStrImageName) && $vStrImageName ==""){
							$vStrImageName = $vResultImage[$v_key_image]['market_image_name'];
						}else{
							$vStrImageName .= ",".$vResultImage[$v_key_image]['market_image_name']; 
						}
					}
				}
				$vResult[$v_key]['market_image_id']  = $vStrImageId;
				$vResult[$v_key]['market_image_type']  = $vStrImageType;
				$vResult[$v_key]['market_image_size']  = $vStrImageSize;
				$vResult[$v_key]['market_image_name']  = $vStrImageName;
				$vResult[$v_key]['last_modified_on'] = parent::__to_display_date($vResult[$v_key]['last_modified_on']);
				$vResult[$v_key]['_rec_modified_on'] = parent::__to_display_date($vResult[$v_key]['_rec_modified_on']);
			}
		}
    return $vResult;
	}

  
  public function market_list_total_search($p_order=null, $p_start = null, $p_num_of_rec = null ,$p_search_keyword,$p_search_category=null,$p_search_location=null ){
		
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = " ORDER BY ".\U::safe_sql_string($v_value['order_by'])." ".\U::safe_sql_string($v_value['sort_by']);
				else $v_order_by .= ", " . \U::safe_sql_string($v_value['order_by']) . " " .\U::safe_sql_string($v_value['sort_by']);
			}
		}
		
		// LIMIT - Coding
		// $v_limit = '';
		// if($p_start !== null && $p_num_of_rec !== null){
			// $v_limit = " LIMIT " . \U::safe_sql_string($p_start) . ", " . \U::safe_sql_string($p_num_of_rec);
			
		// }
		// SEARCH - Coding
		$v_search = '';

		if($p_search_keyword != null){
				if($v_search == '') $v_search = " AND (market_heading LIKE '%".\U::safe_sql_string($p_search_keyword)."%' OR market_description LIKE '%".\U::safe_sql_string($p_search_keyword)."%') ";
		}
		if($p_search_category != null){
				if($v_search == '') {$v_search = " AND market_category = '".\U::safe_sql_string($p_search_category)."' ";}
				else{$v_search .= " AND market_category = '".\U::safe_sql_string($p_search_category)."' ";}
		}
		if($p_search_location != null){
				if($v_search == '') {$v_search = " AND market_location = '".\U::safe_sql_string($p_search_location)."' ";}
				else{$v_search .= " AND market_location = '".\U::safe_sql_string($p_search_location)."' ";}
		}
		

	// QUERY - Coding
		$vQuery = 	"SELECT 
                    COUNT(market_id) AS 'total_rec'
                  FROM " . $this->get_db_table_prefix() . "market
                  WHERE _rec_status = \"SHOW\"				
                  AND market_show_status = \"Activate\"
                  " .$v_search. $v_order_by ;					

		$vResult = parent::execute_query($vQuery);

		return $vResult[0]['total_rec'];
  }
  
   public function market_list_category(){
		// QUERY - Coding
		$vQuery = 	"SELECT DISTINCT
					market_category
                  FROM " . $this->get_db_table_prefix() . "market
                  WHERE _rec_status = \"SHOW\"
                  AND market_category != ''
				  ";
		$vResult = parent::execute_query($vQuery);
		
    return $vResult;
  }
  
  public function market_list_top_ten_item(){
		// modified on 8/3/2012 by wong to change to most recent item
		// QUERY - Coding
		// $vQuery = 	"SELECT 
                    // a.market_id,
                    // a.market_heading,
					// a.market_location,
					// a.market_location_other,
					// a.market_description,
					// a.market_category,
					// a.market_price,
                    // a._rec_modified_on,
					// b.market_image_id,
					// b.market_image_type,
					// b.market_image_size,
					// b.market_image_name
                  // FROM " . $this->get_db_table_prefix() . "market a
				  // left outer join (SELECT distinct parent_id,market_image_id,market_image_type,market_image_size,market_image_name FROM " . $this->get_db_table_prefix() . "market_image group by parent_id) b on a.market_id = b.parent_id 
                  // WHERE _rec_status = \"SHOW\"
				  // AND market_show_status = \"Activate\"
                  // ORDER BY page_hit DESC
				  // LIMIT 0,10
				  // ";
			$vQuery = 	"SELECT 
                    a.market_id,
                    a.market_heading,
					a.market_location,
					a.market_location_other,
					a.market_description,
					a.market_category,
					a.market_price,
                    a._rec_modified_on,
					b.market_image_id,
					b.market_image_type,
					b.market_image_size,
					b.market_image_name
                  FROM " . $this->get_db_table_prefix() . "market a
				  left outer join (SELECT distinct parent_id,market_image_id,market_image_type,market_image_size,market_image_name FROM " . $this->get_db_table_prefix() . "market_image group by parent_id) b on a.market_id = b.parent_id 
                  WHERE _rec_status = \"SHOW\"
				  AND market_show_status = \"Activate\"
                  ORDER BY a.last_modified_on DESC
				  LIMIT 0,10
				  ";
				  
	   // AND ((NOW() >= DATE_ADD(last_modified_on, INTERVAL 3 HOUR)
	   // AND market_show_status = \"Pending\") OR market_show_status = \"Activate\")
		$vResult = parent::execute_query($vQuery);
		
    return $vResult;
  }
  
   /*
   * Function to retrieve the list of market place item's location
   * added by czwong
   */ 
  public function market_list_location(){
		// QUERY - Coding
		$vQuery = 	"SELECT DISTINCT
					market_location
                  FROM " . $this->get_db_table_prefix() . "market
                  WHERE _rec_status = \"SHOW\" 
                  AND market_location != ''
				  ";
		$vResult = parent::execute_query($vQuery);
		
    return $vResult;		
  }

   /*
   * Function to retrieve the list of market place item's status
   * added by Tan
   */ 
  public function market_list_status(){
		// QUERY - Coding
		$vQuery = 	"SELECT DISTINCT
					market_show_status
                  FROM " . $this->get_db_table_prefix() . "market
                  WHERE _rec_status = \"SHOW\" 
				  ";
		$vResult = parent::execute_query($vQuery);
		
    return $vResult;		
  }

	
  /*
   * Function to retrieve the list of market place item for admin
   */
  public function market_list_admin( $p_order=null, $p_start = null, $p_num_of_rec = null, $p_value = null  ){
		$v_cond="";

		//Market status filter
		if(!empty($p_value['status'])){
			$v_cond.= " AND market_show_status='" . \U::safe_sql_string( $p_value['status'] ) . "' ";
		}

		//Market heading and description filter
		if(isset($p_value['search'])){
			if($p_value['search']!=""){
				$v_cond.= " AND (market_heading LIKE '%" . \U::safe_sql_string( $p_value['search'] ) . "%' OR market_description LIKE '%" . \U::safe_sql_string( $p_value['search'] ) . "%') ";
			}
		}

		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = " ORDER BY ".\U::safe_sql_string($v_value['order_by'])." ".\U::safe_sql_string($v_value['sort_by']);
				else $v_order_by .= ", " . \U::safe_sql_string($v_value['order_by']) . " " .\U::safe_sql_string($v_value['sort_by']);
			}
		}
		
		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = " LIMIT " . \U::safe_sql_string($p_start) . ", " . \U::safe_sql_string($p_num_of_rec);
			
		}
		
		// QUERY - Coding
		$v_query = 	"SELECT 
                    market_id,
                    market_heading,
                    market_image_size,
					market_status,
					market_show_status,
                    _rec_modified_on
                  FROM " . $this->get_db_table_prefix() . "market
                  WHERE _rec_status = \"SHOW\"
									{$v_cond}
                  " . $v_order_by . $v_limit;

		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			foreach($v_result as $v_key=>$v_value){
        $v_result[$v_key]['_rec_modified_on'] = parent::__to_display_date($v_result[$v_key]['_rec_modified_on']);
      }
    }

    return $v_result;
  }
  
  /*
   * Function to count the total of market place item
   * Modify by czwong: change from list total of article to market
   */
  public function market_list_total($p_value = null){
		$v_cond="";

		//Market status filter
		if(!empty($p_value['status'])){
			$v_cond.= " AND market_show_status='" . \U::safe_sql_string( $p_value['status'] ) . "' ";
		}

		//Market heading and description filter
		if(isset($p_value['search'])){
			if($p_value['search']!=""){
				$v_cond.= " AND (market_heading LIKE '%" . \U::safe_sql_string( $p_value['search'] ) . "%' OR market_description LIKE '%" . \U::safe_sql_string( $p_value['search'] ) . "%') ";
			}
		}

    // Default Language
    $v_lang_info = \E::get('obj_curr_module')->get_lang();

	// QUERY - Coding
		$v_query = 	"SELECT 
                    COUNT(market_id) AS 'total_rec'
                  FROM " . $this->get_db_table_prefix() . "market
                  WHERE _rec_status = \"SHOW\"
									{$v_cond}
				  ";					

    $v_result = parent::execute_query($v_query);
			
    return $v_result[0]['total_rec'];
  }
  
  /*
   * Function to get market place item detail
   */
  public function market_get( $p_id ){
    // QUERY - market table
		$v_query = 	"SELECT 
                    market_id,
					usr_id,
                    market_heading,
                    market_description,
                    market_category,
					market_user_contact,
                    market_location,
                    market_location_other,
                    market_price,
                    market_image_size,
                    market_status,
					market_show_status,
					market_remark,
					last_modified_on,
                    _rec_modified_on
                  FROM " . $this->get_db_table_prefix() . "market 
                  WHERE _rec_status = \"SHOW\" 
                  AND market_id=\"" . \U::safe_sql_string( $p_id ) . "\"
                ";
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			foreach($v_result as $v_key=>$v_value){
        $v_result[$v_key]['_rec_modified_on'] = parent::__to_display_date($v_result[$v_key]['_rec_modified_on']);
        $v_result[$v_key]['last_modified_on'] = parent::__to_display_date($v_result[$v_key]['last_modified_on']);
      }
    }
    
    return $v_result;
  }
  
  /*
   * Function to update market place item for admin
   */
  public function market_admin_edit( $p_value ){
    $v_query = 	"UPDATE 
                    " . $this->get_db_table_prefix() . "market 
                  SET
                      market_show_status = \"" . \U::safe_sql_string( $p_value['market_show_status'] ) . "\",
                      market_remark = \"" . \U::safe_sql_string( $p_value['market_remark'] ) . "\",
					  _rec_modified_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      _rec_modified_by = \"" . \U::safe_sql_string( $p_value['usr_id'] ) . "\"
                  WHERE 
                    market_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
                ";
    $v_result = parent::execute_query($v_query);
  }
  
  /*
   * Function to update market item page hit
   */
  public function market_add_page_hit( $p_value ){
    $v_query = 	"SELECT page_hit
                 FROM " . $this->get_db_table_prefix() . "market 
                 WHERE market_id = \"" . \U::safe_sql_string( $p_value) . "\"
                ";
    $v_result = parent::execute_query($v_query);
	
	$page_hit = $v_result[0]['page_hit'] + 1;
	
	$v_query = 	"UPDATE 
                    " . $this->get_db_table_prefix() . "market 
                  SET
                      page_hit = \"" . \U::safe_sql_string( $page_hit ) . "\"
                  WHERE 
					  market_id = \"" . \U::safe_sql_string( $p_value) . "\"
                ";
    $v_result = parent::execute_query($v_query);
  }
  
  /*
   * Function to get market place item image info
   */
  public function market_get_image_info( $p_id ){
    // QUERY - market table
		$v_query = 	"SELECT 
                    market_image_id,
                    parent_id,
					market_image_type,
                    market_image_size,
                    market_image_name
                  FROM " . $this->get_db_table_prefix() . "market_image 
                  WHERE parent_id=\"" . \U::safe_sql_string( $p_id ) . "\"
                ";
		$v_result = parent::execute_query($v_query);
		
    return $v_result;
  }
  
  /*
   * Function to count the total of market place item
   * Added by czwong: total of image for market place item
   */
  public function market_get_image_info_total($p_id){
    // Default Language
    $v_lang_info = \E::get('obj_curr_module')->get_lang();

	// QUERY - Coding
		$v_query = 	"SELECT 
                    COUNT(market_image_id) AS 'total_rec'
                  FROM " . $this->get_db_table_prefix() . "market_image
                  WHERE parent_id =\"" . \U::safe_sql_string( $p_id ) . "\"
				  ";					

    $v_result = parent::execute_query($v_query);
			
    return $v_result[0]['total_rec'];
  }

  /*
   * Function to count the total of pending market place item
   * Added by Tan
   */
  public function market_get_pending_count(){
		$v_query = 	"SELECT 
                    COUNT(market_id) AS 'total_rec'
                  FROM " . $this->get_db_table_prefix() . "market
                  WHERE market_show_status =\"Pending\"
                  AND _rec_status = \"SHOW\"
				  ";					

    $v_result = parent::execute_query($v_query);
			
    return $v_result[0]['total_rec'];
  }
	
//******************************************************Market End******************************************************//	
	
	
	
//******************************************************App Start******************************************************//	
	
	public function get_app_all(){
		
		$vQuery = "SELECT * FROM ".$this->get_db_table_prefix()."app WHERE app_web_user = \"1\"";	
		$vResult = parent::execute_query($vQuery);
		if($vResult && is_array($vResult)){
			foreach($vResult as $v_key=>$v_value){
				$vResult[$v_key]['_rec_modified_on'] = parent::__to_display_date($vResult[$v_key]['_rec_modified_on']);
			}
		}

		return $vResult;
	} 
	
	public function get_app_all_cat(){
		
		$vQuery = "SELECT * FROM ".$this->get_db_table_prefix()."app_category WHERE _rec_status=\"SHOW\"";	
		$vResult = parent::execute_query($vQuery);
		if($vResult && is_array($vResult)){
			foreach($vResult as $v_key=>$v_value){
				$vResult[$v_key]['_rec_modified_on'] = parent::__to_display_date($vResult[$v_key]['_rec_modified_on']);
			}
		}

		return $vResult;
	} 
	
	public function get_app($id){
		
		$vQuery = "SELECT * FROM ".$this->get_db_table_prefix()."app WHERE app_id=\"".\U::safe_sql_string($id)."\" ";	
		$vResult = parent::execute_query($vQuery);
		if($vResult && is_array($vResult)){
			foreach($vResult as $v_key=>$v_value){
				$vResult[$v_key]['_rec_modified_on'] = parent::__to_display_date($vResult[$v_key]['_rec_modified_on']);
			}
		}

		return $vResult;
	} 
	
	public function get_app_search($v_category,$v_search_keyword){
		
		if($v_category == "all"){
		$vQuery = "SELECT DISTINCT(b.app_id),b.app_heading,b.app_description,b.usr_id,b.app_detail,b.app_url,b.app_image_type,b.app_image_size,
					b.app_image_name,b._rec_created_on,b._rec_created_by,b._rec_modified_on,b._rec_modified_by FROM ".$this->get_db_table_prefix()."app_sub_cat a 
					LEFT OUTER JOIN ".$this->get_db_table_prefix()."app b on b.app_id=a.app_parent_id 
					WHERE (b.app_heading LIKE \"%".\U::safe_sql_string($v_search_keyword)."%\" or b.app_description LIKE \"%".\U::safe_sql_string($v_search_keyword)."%\" 
					or b.app_detail LIKE \"%".\U::safe_sql_string($v_search_keyword)."%\") 
					AND app_web_user = \"1\"
					";
		}else{
		$vQuery = "SELECT * FROM ".$this->get_db_table_prefix()."app_sub_cat a 
					LEFT OUTER JOIN ".$this->get_db_table_prefix()."app b on b.app_id=a.app_parent_id
					WHERE a.app_cat_id=".\U::safe_sql_string($v_category)." 
					AND (b.app_heading LIKE \"%".\U::safe_sql_string($v_search_keyword)."%\" or b.app_description LIKE \"%".\U::safe_sql_string($v_search_keyword)."%\" 
					or b.app_detail LIKE \"%".\U::safe_sql_string($v_search_keyword)."%\") 
					AND app_web_user = \"1\"
					";
		}
		$vResult = parent::execute_query($vQuery);

		return $vResult;
	} 
	
	public function get_cat_name($id){
		
		$vQuery = "SELECT * FROM ".$this->get_db_table_prefix()."app_category WHERE app_cat_id=\"".\U::safe_sql_string($id)."\" ";	
		$vResult = mysql_query($vQuery,$co_db);
		$vResult = parent::execute_query($vQuery);
		return $vResult;
	} 
	
  public function app_cat_add( $p_value ){
    $v_query = 	"INSERT INTO 
                    " . $this->get_db_table_prefix() . "app_category(
                      app_cat_name,
                      app_cat_desc,
                      _rec_created_on,
                      _rec_created_by,
                      _rec_modified_on,
                      _rec_modified_by,
                      _rec_status
                  )VALUE(
                      \"" . \U::safe_sql_string( $p_value['app_cat_name'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_cat_description'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\"
                  )";
    $v_result = parent::execute_query($v_query);
    return parent::get_last_insert_id();
  }
  
   public function app_add( $p_value ){
    $v_query = 	"INSERT INTO 
                    " . $this->get_db_table_prefix() . "app(
					  usr_id,
                      app_heading,
                      app_description,
                      app_detail,
                      app_category,
					  app_url,
					  app_intranet_user,
					  app_web_user,
					  app_image_type,
                      app_image_size,
                      app_image_name,
                      _rec_created_on,
                      _rec_created_by,
                      _rec_modified_on,
                      _rec_modified_by,
                      _rec_status
                  )VALUE(
				      \"" . \U::safe_sql_string( $_SESSION['usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_heading'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_description'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_detail'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_category'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_url'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_intranet_user'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_web_user'] ) . "\",
					  \"" . \U::safe_sql_string( $p_value['app_icon']['type'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_icon']['size'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_icon']['name'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\"
                  )";
    $v_result = parent::execute_query($v_query);
    return parent::get_last_insert_id();
  }
  
  public function app_add_sub_cat( $p_value ){
    $v_query = 	"INSERT INTO 
                    " . $this->get_db_table_prefix() . "app_sub_cat(
                      app_parent_id,
                      app_cat_id,
                      _rec_created_on,
                      _rec_created_by,
                      _rec_modified_on,
                      _rec_modified_by
                  )VALUE(
                      \"" . \U::safe_sql_string( $p_value['app_parent_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['app_cat_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
                  )";
    $v_result = parent::execute_query($v_query);
  }
  
  public function app_del($p_id){
	$v_query = 	"DELETE FROM 
                    " . $this->get_db_table_prefix() . "app_bookmark 
                  WHERE 
                      app_parent_id = \"" . \U::safe_sql_string( $p_id ) . "\"
                ";
    $v_result = parent::execute_query($v_query);
  }
//******************************************************Market End******************************************************//  


//***********************************************Notification Start******************************************************//
	
	
	public function set_notification($p_value=null){
		
		$v_query = "INSERT INTO 
					". $this->get_db_table_prefix() . "notification(
					notify_category,
					notify_group_id,
					notify_msg,
					notify_url,
					_rec_created_on,
					_rec_created_by,
					_rec_modified_on,
					_rec_modified_by
					)VALUES(
                      \"" . \U::safe_sql_string( $p_value['notify_category'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['notify_group_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['notify_msg'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['notify_url'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
					  \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
					)
				   ";
		
		$v_result = parent::execute_query($v_query);
		return parent::get_last_insert_id();
	}
	
	
	public function set_notification_user($p_group_friend_list=null,$p_value=null){

		if(is_array($p_group_friend_list)){
			$v_value = NULL;
			
			foreach($p_group_friend_list as $v_row){
				if(empty($v_value) || $v_value == ""){
					$v_value .= "(".\U::safe_sql_string($p_value['notify_parent_id']).",".\U::safe_sql_string($p_value['current_usr_id']).",".\U::safe_sql_string($v_row['fg_f_user_id']).",0,\"".\U::safe_sql_string($p_value["current_datetime"])."\",".\U::safe_sql_string($p_value['current_usr_id']).",\"".\U::safe_sql_string($p_value["current_datetime"])."\",".\U::safe_sql_string($p_value["current_usr_id"]).")";
				}else{
					$v_value .= ",(".\U::safe_sql_string($p_value['notify_parent_id']).",".\U::safe_sql_string($p_value['current_usr_id']).",".\U::safe_sql_string($v_row['fg_f_user_id']).",0,\"".\U::safe_sql_string($p_value["current_datetime"])."\",".\U::safe_sql_string($p_value['current_usr_id']).",\"".\U::safe_sql_string($p_value["current_datetime"])."\",".\U::safe_sql_string($p_value["current_usr_id"]).")";
				}
			}
			$v_value .= ";";
			
			$v_query = "INSERT INTO 
						". $this->get_db_table_prefix() . "notification_user(
						notify_parent_id,
						notify_usr_id_from,
						notify_usr_id_to,
						notify_status,
						_rec_created_on,
						_rec_created_by,
						_rec_modified_on,
						_rec_modified_by
						) VALUES 
						".$v_value."
						";
						
			$v_result = parent::execute_query($v_query);
		}else{
			$v_query = "INSERT INTO 
						". $this->get_db_table_prefix() . "notification_user(
						notify_parent_id,
						notify_usr_id_from,
						notify_usr_id_to,
						notify_status,
						_rec_created_on,
						_rec_created_by,
						_rec_modified_on,
						_rec_modified_by
						) VALUES (
						  \"" . \U::safe_sql_string( $p_value['notify_parent_id'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['notify_usr_id_to'] ) . "\",
						  \"0\",
						  \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
						)
						";
				// var_dump($v_query);
			$v_result = parent::execute_query($v_query);
		}		
	}

//***********************************************Notification End******************************************************//

	public function get_acl_list(){
		$v_query="SHOW COLUMNS FROM " . $this->get_db_table_prefix() . "acl_group 
						";
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			foreach($v_result as $v_key=>$v_value){
					if(strpos($v_value['Field'],"group_com")===0){
						$v_result_final[]=$v_value['Field'];
					}
      }
    }
		return $v_result_final;
		/*
		$v_cond="";
		if(!empty($p_id)){
			$v_cond=" AND group_id=\"" . \U::safe_sql_string( $p_id ) . "\" ";
		}
		$v_query="SELECT * FROM " . $this->get_db_table_prefix() . "acl_group 
						WHERE 
						_rec_status=\"SHOW\"
						".$v_cond."
						";
		$v_result = parent::execute_query($v_query);
		if($v_result && is_array($v_result)){
			foreach($v_result as $v_key=>$v_value){
        $v_result[$v_key]['_rec_modified_on'] = parent::__to_display_date($v_result[$v_key]['_rec_modified_on']);
      }
    }

    return $v_result;
		*/
	}

	/*
   * Function to check user group name duplication
   */
  public function user_group_name_duplicate_check( $p_value ){
		$v_cond = "";
		if(isset($p_value['exclude_id']) && $p_value['exclude_id']!=""){
			$v_cond .= " AND NOT kwd_code = \"" . \U::safe_sql_string( $p_value['exclude_id'] ) . "\" ";
		}

		$v_query = "SELECT
									COUNT(*) AS recExist
								FROM " . $this->get_db_table_prefix() . "acl_group_lbl l
								LEFT JOIN " . $this->get_db_table_prefix() . "acl_group g
								ON g.group_id = l.kwd_code
								WHERE kwd_lang = \"" . \U::safe_sql_string( $p_value['lang'] ) . "\"
								AND kwd_value = \"" . \U::safe_sql_string( $p_value['group_name'] ) . "\"
								AND l._rec_status = 'SHOW'
								AND g._rec_status = 'SHOW'
								{$v_cond}
								";
		$v_result = parent::execute_query($v_query);
		return $v_result[0];
	}

	/*
   * Function to add user group
   */
  public function user_group_add( $p_value ){
    for($v_c=0; $v_c<$p_value['comp_count']; $v_c++){
      $v_fields_list .= $p_value['acl'][$v_c]['name'].', ';
      $v_value_list .= '"' . \U::safe_sql_string( $p_value['acl'][$v_c]['value'] ) . '", ';
    }

    $v_query = 	"INSERT INTO 
                    " . $this->get_db_table_prefix() . "acl_group(
                      " . $v_fields_list . "
											is_counselor,
                      _rec_created_on,
                      _rec_created_by,
                      _rec_modified_on,
                      _rec_modified_by,
                      _rec_status
                  )VALUE(
                      " . $v_value_list . "
                      \"" . \U::safe_sql_string( $p_value['is_counselor'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      \"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\"
                  )";
									// print $v_query;
    $v_result = parent::execute_query($v_query);
    return parent::get_last_insert_id();
  }
	
	  /*
   * Function to add user group label
   */
  public function user_group_lbl_add( $p_value ){
    $v_rec_value="(
                    \"" . \U::safe_sql_string( $p_value['id'] ) . "\",
                    \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                    \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                    \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                    \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                  ";
    $v_rec_value_list = "";
    $v_lang_info = \E::get('obj_curr_module')->get_supported_lang();
    foreach($v_lang_info as $v_lang){
      if($v_rec_value_list!=""){
        $v_rec_value_list .= ",";
      }
      $v_rec_value_list .= $v_rec_value;
      $v_rec_value_list .= "\"" . \U::safe_sql_string( $v_lang ) . "\",";
      $v_rec_value_list .= "\"" . \U::safe_sql_string( $p_value['group_name'][$v_lang] ) . "\"";
      $v_rec_value_list .= ")";
    }

		$v_query = 	"INSERT INTO 
                    " . $this->get_db_table_prefix() . "acl_group_lbl(
                      kwd_code,
                      _rec_created_on,
                      _rec_created_by,
                      _rec_modified_on,
                      _rec_modified_by,
                      kwd_lang,
                      kwd_value
                  )VALUE{$v_rec_value_list}";

    $v_result = parent::execute_query($v_query);
  }

  /*
   * Function to update user group details
   */
  public function user_group_edit( $p_value ){
    for($v_c=0; $v_c<$p_value['comp_count']; $v_c++){
      $v_update_list .= ''.$p_value['acl'][$v_c]['name'].' = "' . \U::safe_sql_string( $p_value['acl'][$v_c]['value'] ) . '", ';
    }

    $v_query = 	"UPDATE 
                    " . $this->get_db_table_prefix() . "acl_group 
                  SET
                    {$v_update_list}
										is_counselor = \"" . \U::safe_sql_string( $p_value['is_counselor'] ) . "\",
                    _rec_modified_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                    _rec_modified_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
                  WHERE 
                    group_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
                ";
								// print $v_query;
    $v_result = parent::execute_query($v_query);
  }

  /*
   * Function to update user group label
   */
  public function user_group_lbl_edit( $p_value ){
    $v_lang_info = \E::get('obj_curr_module')->get_supported_lang();
    foreach($v_lang_info as $v_lang){
      $v_query = 	"UPDATE 
                      " . $this->get_db_table_prefix() . "acl_group_lbl
                    SET 
                        kwd_value = \"" . \U::safe_sql_string( $p_value['group_name'][$v_lang] ) . "\",
                        _rec_created_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                        _rec_created_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                        _rec_modified_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                        _rec_modified_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\"
                    WHERE
                      kwd_code = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
                    AND
                      kwd_lang = \"" . \U::safe_sql_string( $v_lang ) . "\"
                  ";
      $v_result = parent::execute_query($v_query);
    }
  }

  /*
   * Function to soft delete user group
   */
  public function user_group_soft_del( $p_value ){
    $v_query = 	"UPDATE 
                    " . $this->get_db_table_prefix() . "acl_group 
                  SET
                      _rec_deleted_on = \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
                      _rec_deleted_by = \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
                      _rec_status = \"DELETED\"
                  WHERE 
                      group_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
                ";
    $v_result = parent::execute_query($v_query);

    if($v_result){
      return true;
    }else{
      return false;
    }
  }

  /*
   * Function to hard delete user group
   */
  public function user_group_hard_del( $p_value ){
    $v_query = 	"DELETE FROM 
                    " . $this->get_db_table_prefix() . "acl_group_lbl 
                  WHERE 
                      kwd_code = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
                ";
    $v_result = parent::execute_query($v_query);

    $v_query = 	"DELETE FROM 
                    " . $this->get_db_table_prefix() . "acl_group 
                  WHERE 
                      group_id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
                ";
    $v_result = parent::execute_query($v_query);

    if($v_result){
      return true;
    }else{
      return false;
    }
  }
  
    public function user_get_admin_usr_id($p_value){
		
		$p_group = "";
		switch ($p_value['component']){
			case 'entrepreneur':
				$p_group ='group_com_entrepreneur_profile = 15';
				break;
			case 'singlemother':
				$p_group ='group_com_singlemother_profile = 15';
				break;
			case 'ngo':
				$p_group ='group_com_ngo_profile = 15';
				break;
			case 'gender':
				$p_group ='group_com_gender_profile = 15';
				break;
			case 'counseling':
				$p_group ='group_com_counseling_profile = 15';
				break;
			default:
				$p_group ='group_com_'.$p_value['component'].' = 15';
		}
		
		$v_query = "SELECT 
						usr_id 
					FROM " . $this->get_db_table_prefix() . "acl_user_group 
					WHERE group_id IN (
						SELECT 
							group_id 
						FROM " . $this->get_db_table_prefix() . "acl_group 
						where $p_group)
					";
		// print $v_query;
		$v_result = parent::execute_query($v_query);
		return $v_result;
	}

//***********************************************Event Start******************************************************//
	public function event_status_count( $p_value ){
    $v_id_filter = "";
    if(!empty($p_value['event_id'])){
      $v_id_filter = " AND event_id='" . \U::safe_sql_string( $p_value['event_id'] ) . "' ";
    }

    $v_type_filter = "";
    if(!empty($p_value['event_type'])){
      $v_type_filter = " AND event_type='" . \U::safe_sql_string( $p_value['event_type'] ) . "' ";
    }

    $v_query = "SELECT 
                    COUNT(usr_id) as sumrec,
										event_attend_status
                  FROM " . $this->get_db_table_prefix() . "event_status
                  WHERE 0=0
                  {$v_id_filter}
                  {$v_type_filter}
									GROUP BY event_attend_status
									ORDER BY event_attend_status ASC
                ";

    $v_result = parent::execute_query($v_query);
    return $v_result;
	}

	public function event_status_user( $p_value ){
    $v_id_filter = "";
    if(!empty($p_value['event_id'])){
      $v_id_filter = " AND event_id='" . \U::safe_sql_string( $p_value['event_id'] ) . "' ";
    }

    $v_type_filter = "";
    if(!empty($p_value['event_type'])){
      $v_type_filter = " AND event_type='" . \U::safe_sql_string( $p_value['event_type'] ) . "' ";
    }

    $v_status_filter = "";
    if(!empty($p_value['event_attend_status'])){
      $v_type_filter = " AND event_attend_status='" . \U::safe_sql_string( $p_value['event_attend_status'] ) . "' ";
    }

		// LIMIT - Coding
		$v_limit = '';
		if($p_value['start'] !== null && $p_value['num_of_rec'] !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_value['start']) . ', ' . \U::safe_sql_string($p_value['num_of_rec']);
			
		}

    $v_query = "SELECT 
                    usr_id
                  FROM " . $this->get_db_table_prefix() . "event_status
                  WHERE 0=0
                  {$v_id_filter}
                  {$v_type_filter}
                  {$v_status_filter}
									{$v_limit}
                ";

    $v_result = parent::execute_query($v_query);
    return $v_result;
	}

	public function event_status_user_total( $p_value ){
    $v_id_filter = "";
    if(!empty($p_value['event_id'])){
      $v_id_filter = " AND event_id='" . \U::safe_sql_string( $p_value['event_id'] ) . "' ";
    }

    $v_type_filter = "";
    if(!empty($p_value['event_type'])){
      $v_type_filter = " AND event_type='" . \U::safe_sql_string( $p_value['event_type'] ) . "' ";
    }

    $v_status_filter = "";
    if(!empty($p_value['event_attend_status'])){
      $v_type_filter = " AND event_attend_status='" . \U::safe_sql_string( $p_value['event_attend_status'] ) . "' ";
    }

    $v_query = "SELECT 
                    COUNT(usr_id) AS total_rec
                  FROM " . $this->get_db_table_prefix() . "event_status
                  WHERE 0=0
                  {$v_id_filter}
                  {$v_type_filter}
                  {$v_status_filter}
									{$v_limit}
                ";

    $v_result = parent::execute_query($v_query);
    return $v_result[0]['total_rec'];
	}
//***********************************************Event End******************************************************//

//***********************************************Status Start******************************************************//
	public function status_list(){
		$v_query = "SELECT 
										status_usr_id,
										status_usr_status,
										status_start_date,
										status_end_date,
										status_start_session,
										status_end_session,
										status_remark
                  FROM " . $this->get_db_table_prefix() . "status
                  WHERE _rec_status='SHOW'
									AND curdate() BETWEEN status_start_date AND status_end_date
									ORDER BY status_usr_status ASC
                ";

    $v_result = parent::execute_query($v_query);
		foreach($v_result as $v_key=>$v_value){
			$v_result[$v_key]['status_start_date'] = parent::__to_display_date($v_value['status_start_date'], "DATE");
			$v_result[$v_key]['status_end_date'] = parent::__to_display_date($v_value['status_end_date'], "DATE");
		}
		return $v_result;
	}
//***********************************************Status End******************************************************//

	/*
	* Function to retrieve the list of post which post to all user regardless of friendship. Use table t_intranet_wall_post.
	*/
	public function wall_list_everyone( $p_order=null, $p_start = null, $p_num_of_rec = null, $p_value=NULL){
		
		// ORDER BY - Coding
		$v_order_by = '';
		if($p_order != null){
			foreach($p_order as $v_value){
				if($v_order_by == '') $v_order_by = ' ORDER BY p.'.$v_value['order_by'].' '.$v_value['sort_by'];
				else $v_order_by .= ', p.' . $v_value['order_by'] . ' ' .$v_value['sort_by'];
			}
		}

		// LIMIT - Coding
		$v_limit = '';
		if($p_start !== null && $p_num_of_rec !== null){
			$v_limit = ' LIMIT ' . \U::safe_sql_string($p_start) . ', ' . \U::safe_sql_string($p_num_of_rec);
		}

		$v_cond="";
		$v_tbl_postfix="";

		$v_cond=""; //reset cond
		
		if(!empty($p_value['prev_id'])){
			$v_cond .=" AND p.post_id<".\U::safe_sql_string($p_value['prev_id'])." ";
		}
				// QUERY - Coding
				$v_query = 	"SELECT 
												p.post_id,
												p.post_user,
												u.pic_id,
												p.post_category,
												p.post_content,
												p.post_group,
												p._rec_modified_on,
												\"everyone\" as group_type
											FROM " . $this->get_db_table_prefix() . "wall_post_everyone p 
											LEFT JOIN " . $this->get_db_table_prefix() . "user_pref u
											ON p.post_user=u.usr_id
											WHERE p._rec_status = \"SHOW\"
												".$v_cond."
											 " . $v_order_by . $v_limit;
											 // print "<br/>".$v_query;
				$v_result_post = parent::execute_query($v_query);
				if($v_result_post && is_array($v_result_post)){
					foreach($v_result_post as $v_key=>$v_value){
					
						$v_result_post[$v_key]['_rec_modified_on'] = parent::__to_display_date($v_result_post[$v_key]['_rec_modified_on']);
						//note here
						// $v_user=\E::get('obj_system_module')->get_user_info($v_result_post[$v_key]['post_user']);
						// $v_result_post[$v_key]['post_user_full_name'] = $v_user['full_name'];
						// unset($v_user);
						
						$v_ary_id[]=\U::safe_sql_string($v_result_post[$v_key]['post_id']); //to be use in next query
						$v_ary_postkey[$v_result_post[$v_key]['post_id']]=$v_key; //so that i can search the result with post_id
						// if($v_result_post[$v_key]['post_category']=="photo"){
							
						// }
						/*
						if(!empty($v_result_post[$v_key]['commentdata'])){
							$v_array_comment=explode(",",$v_result_post[$v_key]['commentdata']);
							while(count($v_array_comment)>0){
								$v_cur_user=array_shift($v_array_comment); // 0,2,4,6,8 etc is user id
								$v_cur_comment=array_shift($v_array_comment); //1,3,5,7,9,11,13 etc is comment
								$v_result_post[$v_key]['comment'][]=array('user'=>$v_cur_user,'comment'=>$v_cur_comment);
							}
						}
						*/
						
					}
					$v_str_id=implode(",",$v_ary_id); //to be use in next query
				}
		
		if(!empty($v_str_id)){
			$v_query = 	"SELECT c.post_id,c.cmt_id,u.pic_id,c.cmt_user,c.cmt_content,c._rec_modified_on 
										FROM " . $this->get_db_table_prefix() . "wall_comment_everyone c LEFT JOIN " . $this->get_db_table_prefix() . "user_pref u
										ON c.cmt_user=u.usr_id
										WHERE 
										c.post_id IN (".$v_str_id.") AND c._rec_status=\"SHOW\" ORDER BY c._rec_created_on
									";
									// print $v_query;
			$v_result_comment = parent::execute_query($v_query);
			foreach($v_result_comment as $v_key=>$v_value){
			
				$v_curr_commment_row=$v_result_comment[$v_key]; //current comment row
				
				$v_curr_post_key=$v_ary_postkey[$v_curr_commment_row['post_id']]; //current post key, by matching comment.post id with post.post_id. Refer previous query above.
				
				// $v_user=\E::get('obj_system_module')->get_user_info($v_curr_commment_row['cmt_user']);
				
				$v_result_post[$v_curr_post_key]['comment'][]=array(
																											'user'=>$v_curr_commment_row['cmt_user'],
																											'comment_id'=>$v_curr_commment_row['cmt_id'],
																											'comment'=>$v_curr_commment_row['cmt_content'],
																											'pic_id'=>$v_curr_commment_row['pic_id'],
																											'_rec_modified_on'=>parent::__to_display_date($v_curr_commment_row['_rec_modified_on'])
																											);
				
				unset($v_user);
			}
		}
	return $v_result_post;
	}
	
	public function wall_add( $p_value ){
		$v_query = 	"INSERT INTO 
						" . $this->get_db_table_prefix() . "wall_post".$p_value['tbl_postfix']."(
						  post_user,
						  post_category,
						  post_content,
						  post_group,
						  _rec_created_on,
						  _rec_created_by,
						  _rec_modified_on,
						  _rec_modified_by,
						  _rec_status
					  )VALUE(
						  \"" . \U::safe_sql_string( $p_value['post_usr_id'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['post_category'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['post_content'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['post_group'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['current_datetime'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['current_usr_id'] ) . "\",
						  \"" . \U::safe_sql_string( $p_value['_rec_status'] ) . "\"
					  )";
		$v_result = parent::execute_query($v_query);
		return parent::get_last_insert_id();
	}




}
?>