<?php
$v_path = MOONLIGHT_PLUGIN_FULL_PATH . 'jquery-qtip2/';
$v_ver = isset($v_ver) ? $v_ver : '2.0.0';
?>
<script type="text/javascript" src="<?php echo $v_path;?>dist/<?php echo $v_ver;?>/jquery.qtip.min.js"></script>
<link rel="stylesheet" type="text/css" href="<?php echo $v_path;?>dist/<?php echo $v_ver;?>/jquery.qtip.css" />
<style>
	.qtip_hr{
		margin: 0px -9px;
		color: #F1F1F1;
	}
	.qtip_custom_top_area{
		margin: -3px -9px 0px -9px;
		background-color:#F1F1F1;
		padding:8px 3px;
		border-bottom:1px solid #808080;
	}
	
	.qtip_custom_top_area .title{
		font-weight: bold;
		font-size:1.2em;
		display:inline;
	}
	.qtip_custom_top_area .content{
		margin: 0px 9px 0px 9px;
		line-height:1.3;
	}
	.qtip_custom_bottom_area{
		margin: 0px -9px -3px -9px;
		padding:3px;
		background-color:#F1F1F1;
		border-top:1px solid #808080
	}
	
	.qtip_custom_bottom_area .content{
		margin: 0px 9px 3px 9px;
		line-height:1.3;
	}
	.qtip_custom_area{
		margin: 0px -9px 0px -9px;
		padding:3px;
		/*background-color:#F1F1F1;*/
		border-bottom:0px solid #808080
	}
	.qtip_custom_area .title{
		font-weight: bold;
		font-size:1.2em;
		display:inline;
	}
	.qtip_custom_area .content{
		margin: 0px 9px 0px 9px;
		line-height:1.3;
	}
	
	/* Overwrite Styles in jquery.qtip.css*/
	.ui-tooltip-titlebar{
		position: relative;
		/*min-height: 14px;*/
		min-height: 1px;
		/*padding: 8px 35px 8px 10px;*/
		padding: 0px 35px 1px 10px;
		overflow: hidden;
		border-width: 0 0 1px;
		font-weight: bold;
		font-size:1.2em;
	}
	.qtip{
		max-width: 800px;
	}
	.qtip-default{
		border: 1px solid #888888;
		background-color: #FFFFFF;
		color: #555;
	}
	#qtip-overlay.blurs{ 
		cursor: default;
	}
	.ui-tooltip, .qtip {
		max-width:90%;
		font-size:inherit;
	}	
	.ui-tooltip-content{
		background-color: transparent;
		overflow:auto;
	}
</style>
<script type="text/javascript">
<?php
	/* Extra Attributes 
		======================================
		DATATYPE	ATTRIBUTES			DESCP
		=======================================
		string		qtip_id							qtip id. Used for internal page qtip. Value of qtip id will be another element id.
		string		ajax_id							ajax qtip id (Not require if qtip_id is set)
		string		ajax_url						ajax url (Not require if qtip_id is set) 
		string		ajax_callback					callback function
		string		ajax_position_at				position of tooltip
		string		ajax_position_my				position of arrow
		string		ajax_position_adjust_method		adjust method of position '<flip|flipinvert|shift|none> <flip|flipinvert|shift|none>'
		string 		ajax_width						qtip width in px
		bool 		ajax_ready 						autopopup (default: false)
		bool 		ajax_no_cache 					disable caching ( default: true)
		int 		ajax_zIndex						set zIndex on qtip
		int 		style_tip_mimic					To override what corner type is rendered. ( default: false)
		int 		style_tip_offset				tip offset. ( default: 0)
		string 		event_type						event to trigger qtip (default: click)
		string 		ajax_hide						event to hide qtip (unfocus/click/mouseout/false)
		function	ajax_event_hidden				function to trigger when onHide
		function	ajax_event_show					function to trigger when onShow
		function	ajax_event_render				function to trigger when onRender
		function	ajax_event_visible				function to trigger when onVisible
		function	ajax_event_hide					function to trigger when onHide
		function	ajax_event_move					function to trigger when onMove
		function	ajax_event_blur					function to trigger when onBlur
		function	ajax_event_focus				function to trigger when onFocus
	*/
?>
function init_jquery_qtip(p_id){
		// Make sure to only match links to wikipedia with a rel tag
		p_tag = p_id != null ? $('#' + p_id) : '.qtipPopupTrigger';
		$(p_tag).each(function()
		{
			var parent_obj = this; 
		
			var v_fullscreen = parent_obj.parentNode.id == 'qtipPopupContainer' ? true : false;
			// We make use of the .each() loop to gain access to each element via the "this" keyword...
			$(this).qtip(
			{
			
				id: $(this).attr('ajax_id'),
				content: {
					// Set the text to an image HTML string with the correct src URL to the loading image you want to use
					text: $(this).attr('qtip_id') ? $('#' + $(this).attr('qtip_id')) : $(this).attr('qtips') ? $(this).attr('qtips') : "<center><table width=100% cellpadding=0 cellspacing=0 ><tr><td align=right width=48%><?php echo \R::get_image_tag("DIV_LOADING"); ?></td><td>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo \E::get('obj_kernel_lang')->get("AJAX_LOADING");?></td></tr></table></center>",
					ajax: {
						// Use the rel attribute of each element for the url to load
						url: $(this).attr('ajax_url') ? $(this).attr('ajax_url').split("?")[1]==null 
															? $(this).attr('ajax_url') + $(this).attr('ajax_id') + '/' 
															: $(this).attr('ajax_url').replace("?", $(this).attr('ajax_id')+"/?")
													: '', 
						// data: { id: $(this).val() },
						data: '',
						once : $(this).attr('ajax_no_cache')!=null ? false : true,
						loading: true,
						type: 'GET', // POST or GET
						success: function(data, status) {
							// Process the data
							// Set the content manually (required!)
							if( v_fullscreen ){
								this.set('content.text', '<center><table><tr><td>'+data+'</td></tr></table></center>');
							}else{
								this.set('content.text', data);
							}
							
							//== ajax callback
							var fn = window[$(parent_obj).attr('ajax_callback')]; 
							if(typeof fn === 'function') {
								fn();
							}
						}
					},
					title: {
						text: $(this).attr('ajax_header')!=null ? '<span></span>' : false,
						// text: $(this).attr('ajax_title'), // Give the tooltip a title using each elements text
						// text: "<br>", // Give the tooltip a title using each elements text
						button: false
					}
				},
				position: {
					type: 'relative',
					at: $(this).attr('ajax_position_at') ? $(this).attr('ajax_position_at') : 'bottom center', // Position the tooltip above the link
					my: $(this).attr('ajax_position_my') ? $(this).attr('ajax_position_my') : 'top left',
					viewport: $(window), // Keep the tooltip on-screen at all times
					// viewport: false, // Keep the tooltip on-screen at all times
					effect: false, // Disable positioning animation
					adjust: {
						method: $(this).attr('ajax_position_adjust_method') ? $(this).attr('ajax_position_adjust_method') : 'flip flip'
					},
					corner: {
						// target: 'bottomRight',
						// tooltip: 'topLeft'
						// adjust : {
							// screen : true
						// },
						target: 'center',
						tooltip: 'center'
					},
					target: v_fullscreen ? $(window) : $(this)
				},
				
				style: {
					tip: {
						width:13,
						height:13,
						show: true,
						mimic: $(this).attr('style_tip_mimic') ? $(this).attr('style_tip_mimic') : false,
						offset: $(this).attr('style_tip_offset') ? parseInt($(this).attr('style_tip_offset')) : 0
					},
					
					classes: 'ui-tooltip-wiki ui-tooltip-light ui-tooltip-shadow',
					width: $(this).attr('ajax_width') ? $(this).attr('ajax_width') : 'auto',
					zIndex: $(this).attr('ajax_zIndex') ? $(this).attr('ajax_zIndex') : 'auto'
				},
				hide: {
					  event: $(this).attr('ajax_hide') ? $(this).attr('ajax_hide') : 'unfocus'
				 },
				show: {
					 modal: {
						on: v_fullscreen ? true : false,
						blur: v_fullscreen ? true : false
					},
					event:$(this).attr('event_type')==null? 'click': $(this).attr('event_type'),
					delay: $(this).attr('event_delay')!=null ? $(this).attr('event_delay') : 90, //default as 90 miliseconds
					solo: false, // Only show one tooltip at a time
					ready: $(this).attr('ajax_ready')!=null ? true : false // Show the tooltip as soon as it's bound, vital so it shows up the first time you hover!
				},
				
				events: {
					hide: function(event, api) {
						var fn = window[$(parent_obj).attr('ajax_event_hide')]; 
						if(typeof fn === 'function') {
							fn();
						}
					},
					hidden: function(event, api) {
						var fn = window[$(parent_obj).attr('ajax_event_hidden')]; 
						if(typeof fn === 'function') {
							fn();
						}
						//== destroy qtip object for fullscreen mode
						if( v_fullscreen ){
							document.getElementById('qtipPopupContainer').innerHTML = '';
							$(parent_obj).qtip('destroy');
						}
					},
					show: function(event, api) {
						var fn = window[$(parent_obj).attr('ajax_event_show')]; 
						if(typeof fn === 'function') {
							fn();
						}
					},
					render: function(event, api) {
						var fn = window[$(parent_obj).attr('ajax_event_render')]; 
						if(typeof fn === 'function') {
							fn();
						}
					},
					visible: function(event, api) {
						//== for popup iframe
						open_qtip_iframe_visible(event, api, parent_obj);
						var fn = window[$(parent_obj).attr('ajax_event_visible')]; 
						if(typeof fn === 'function') {
							fn();
						}
					},
					move: function(event, api) {
						var fn = window[$(parent_obj).attr('ajax_event_move')]; 
						if(typeof fn === 'function') {
							fn();
						}
					},
					focus: function(event, api) {
						var fn = window[$(parent_obj).attr('ajax_event_focus')]; 
						if(typeof fn === 'function') {
							fn();
						}
					},
					blur: function(event, api) {
						var fn = window[$(parent_obj).attr('ajax_event_blur')]; 
						if(typeof fn === 'function') {
							fn();
						}
					}
				}
				
			})
		})
		// Make sure it doesn't follow the link when we click it
		.click(function(event) { event.preventDefault(); });
}

function open_qtip_iframe_visible(event, api, p_obj){
	if( $(p_obj).attr('ajax_url')==null && $(p_obj).attr('ajax_iframe_url')!=null){
		v_random = new Date().getTime();
		v_frame_id = 'iframe_qtip_' + v_random;
		v_height = $(p_obj).attr('ajax_height') ? $(p_obj).attr('ajax_height') : '100';
		api.set({
			'content.text': '<iframe id="'+v_frame_id+'" style="visibility:hidden;border:0; width:100%; height: ' + v_height + '" src="'+$(p_obj).attr('ajax_iframe_url')+'"></iframe>',
			'style.height': 100
		});
		$('#' + v_frame_id).load(function() {
			$('#' + v_frame_id).parent().css('padding', '0');
			if($(p_obj).attr('ajax_height') == null){
				v_height = this.contentWindow.document.body.offsetHeight;
			}
			api.set({
				'style.height': v_height
			 });
			$('#' + v_frame_id).attr('height', v_height + 'px');
			api.reposition();
			$('#' + v_frame_id).css("visibility","visible");
			
			//== ajax callback
			var fn = window[$(p_obj).attr('ajax_callback')];
			if(typeof fn === 'function') {
				fn();
			}
		});
	}
}

function open_qtip_iframe_hidden(event, api, p_obj){
	if( $(p_obj).attr('ajax_iframe_url')!=null){
		if(document.getElementById('div_qtip_area')) document.getElementById('div_qtip_area').innerHTML = '';
		$(p_obj).qtip('destroy');
	}
}

function close_qtip(p_id){
	p_id==null ? $('.qtipPopupTrigger').qtip("hide") : "";
	//== hide fullscreen popup qtip if necessary
	// $('#qtipPopupWrapper').qtip("hide");
	// $('#qtipPopupWrapper').qtip('destroy');
	$('#qtipPopupContainer').empty('#qtipPopupWrapper');
	// document.getElementById('qtipPopupContainer').innerHTML = '';
}

function open_qtip_ajax(p_url, p_callback){
	
	var v_obj = document.createElement('div');
	v_obj.setAttribute('id', 'qtipPopupWrapper');
	v_obj.setAttribute('ajax_ready', 'true');
	v_obj.setAttribute('ajax_position_at', 'center');
	v_obj.setAttribute('ajax_position_my', 'center');
	v_obj.setAttribute('ajax_id', 'div_qtip_area_ajax');
	v_obj.setAttribute('ajax_width', '99.9%');
	v_obj.setAttribute('ajax_target', 'window');
	v_obj.setAttribute('ajax_url', p_url);
	v_obj.setAttribute('ajax_callback', p_callback);
	
	//== append into qtip area
	document.getElementById('qtipPopupContainer').appendChild(v_obj);
	
	//== initiate 
	init_jquery_qtip('qtipPopupWrapper');
}

function open_qtip_iframe(p_url, p_callback, p_height){
	var v_obj = document.createElement('div');
	v_obj.setAttribute('id', 'qtipPopupWrapper');
	v_obj.setAttribute('ajax_ready', 'true');
	v_obj.setAttribute('ajax_position_at', 'center');
	v_obj.setAttribute('ajax_position_my', 'center');
	v_obj.setAttribute('ajax_width', '99.9%');
	p_height != null && p_height != '' ? v_obj.setAttribute('ajax_height', p_height) : '';
	v_obj.setAttribute('ajax_target', 'window');
	v_obj.setAttribute('ajax_iframe_url', p_url);
	v_obj.setAttribute('ajax_callback', p_callback);
	
	document.getElementById('qtipPopupContainer').appendChild(v_obj);
	
	//== initiate 
	init_jquery_qtip('qtipPopupWrapper');
}

// Create the tooltips only on document load
$(document).ready(function()
{
	init_jquery_qtip();
	
});

</script>