<?php
$v_path = MOONLIGHT_PLUGIN_FULL_PATH . 'jquery-select2/3.5.2/';
?>

<script src="<?php echo $v_path?>select2.min.js"></script>
<link href="<?php echo $v_path?>select2.css" rel="stylesheet" />
<link href="<?php echo $v_path?>custom.css" rel="stylesheet" />

<script language="javascript">
	/* http://select2.github.io/select2/ */
function init_jquery_select2(p_id){
	p_tag = p_id != null ? 'select' + '#' + p_id : 'select.select2, select.select2_compulsory';
	p_tag_ajax = p_id != null ? 'input:hidden[ajax_url]' + '#' + p_id : 'input:hidden[ajax_url].select2';
	 //Combobox without AJAX 
	$(p_tag).each(function(){
		var parent_obj = this;
		$(this).select2({
			minimumResultsForSearch: 10,
			locale: 'zh-CN',
			width: function(e){
				if(parent_obj.style.width){
					return parent_obj.style.width;
				}else{
					return '100%';
				}
			},
			matcher: function(term, text, opt){
				if( opt.parent("optgroup").attr("label") ){
					return text.toUpperCase().indexOf(term.toUpperCase())>=0 || opt.parent("optgroup").attr("label").toUpperCase().indexOf(term.toUpperCase())>=0
				}else{
					return text.toUpperCase().indexOf(term.toUpperCase())>=0
				}				
			},
			placeholder: $(this).attr("placeholder") ? $(this).attr("placeholder") : "",
			allowClear: true
		}).on('change', function(e){
			var fn = window[$(this).attr('onchange')];
			if( typeof(fn) === 'function'){
				fn( e.val );
			}
		});
	});
	  //Combobox with AJAX 
	$(p_tag_ajax).each(function(){
		var parent_obj = this;
		p_data = $(this).attr('data');
		//== Multiple selection
		if($(this).attr('multiple') != null){
			$(this).select2({
				width: function(e){
					if(parent_obj.style.width){
						return parent_obj.style.width;
					}else{
						return '100%';
					}
				},
				placeholder: $(this).attr("placeholder") ? $(this).attr("placeholder") : "",
				allowClear: true,
				multiple: true,
				separator: '@@@',
				tokenSeparators: ['@@@','/n'],
				minimumInputLength: 2,
				formatInputTooShort: function () {
					return "<?php echo \E::get('obj_kernel_lang')->get('AUTOCOMPLETE_TIPS');?>";
				},  
				formatResult: function(result, container, query, escapeMarkup) {
					v_return = result.text;
					if(result.desc){
						v_return += '<br><span class="select2-result-desc">' + result.desc + '</span>';
					}
					return v_return;
				},
				formatSelection: function (data, container, escapeMarkup) {
					return data ? escapeMarkup(data.value) : undefined;
				},
				ajax: {
					url: $(this).attr('ajax_url') ? $(this).attr('ajax_url') : "#",
					dataType: 'json',
					type: "GET",
					quietMillis: 500,
					data: function (term, page) {
						term = term.replace(/</g, '&lt;').replace(/>/g, '&gt;');
						if($(parent_obj).attr('allow_new')!=null){
							return {
								term: term,
								allow_new: 1
								// page_limit: 10,
								// page: page
							};
						}else{
							return {
								term: term
								// page_limit: 10,
								// page: page
							};
						}
					},
					results: function (data, page) {
						return {
							// more: (page * 10) < data.total,
							results: $.map(data, function (item) {
								return {
									id: item.id,
									text: item.label,
									value: item.value,
									desc: item.desc
								}
							})
						};
					}
				},
				/*
				initSelection: function (e, callback) {
					if( $(parent_obj).attr('allow_new')!=null ){
						v_value = { id: (e.val()), allow_new: 1 };
					}else{
						v_value = { id: (e.val()) };
					}
					return $.ajax({
						type: 'POST',
						url: $(parent_obj).attr('ajax_url') ? $(parent_obj).attr('ajax_url') : "#",
						dataType: 'json',
						data: v_value,
					
						success: function(data){
							var results = [];
							if( $(parent_obj).attr('allow_new')!=null ){
								var match = $.map(data, function(value, key){
									return value['id'];
								});
								var str = e.val().split('@@@');
								$.each(str, function(key, item){
									if($.inArray(item, match) == -1){
										results.push({
										  id: item,
										  text: item,
										  value: item,
										  desc: item
										});
									}
								});
							}
							
							for(key in data){
								results.push({
								  id: data[key].id,
								  text: data[key].label,
								  value: data[key].value,
								  desc: data[key].desc
								});
							}
							callback(results);
						}
					});
				},
				*/
				createSearchChoice:function(term, data) {
					//== allow custom value
					if( $(parent_obj).attr('allow_new')!=null ){
						if ( $(data).filter( function() {
							return this.text.localeCompare(term)===0;
						}).length===0) {
							return {id:term, text: term.replace(/</g, '&lt;').replace(/>/g, '&gt;'), value: term};
						}
					}
				},
			}).on('change', function(e){
			}).on('select2-loaded', function(e){
			}).on('select2-focus', function(e){
			}).on('select2-removed', function(e){
				var fn = window[$(this).attr('ajax_callback')];
				if( typeof(fn) === 'function'){
					fn( e.val, e.choice.value, 'REMOVED');
				}
			}).on('select2-selecting', function(e){
				var fn = window[$(this).attr('ajax_callback')];
				if( typeof(fn) === 'function'){
					fn( e.val, e.object.value, 'SELECTING');
				}
			});
			//== to set default data
			if(p_data != null && p_data != ''){
				$(this).select2("data", JSON.parse(p_data) );
			}
		}else{
			//== Single selection
			$(this).select2({
				width: function(e){
					if(parent_obj.style.width){
						return parent_obj.style.width;
					}else{
						return '100%';
					}
				},
				placeholder: $(this).attr("placeholder") ? $(this).attr("placeholder") : "",
				allowClear: true,
				minimumInputLength: 2,
				formatInputTooShort: function () {
					return "<?php echo \E::get('obj_kernel_lang')->get('AUTOCOMPLETE_TIPS');?>";
				},  
				formatResult: function(result, container, query, escapeMarkup) {
					v_return = result.text;
					if(result.desc){
						v_return += '<br><span class="select2-result-desc">' + result.desc + '</span>';
					}
					return v_return;
				},
				formatSelection: function (data, container, escapeMarkup) {
					return data ? escapeMarkup(data.value) : undefined;
				},
				ajax: {
					url: $(this).attr('ajax_url') ? $(this).attr('ajax_url') : "#",
					dataType: 'json',
					type: "GET",
					quietMillis: 500,
					data: function (term, page) {
						term = term.replace(/</g, '&lt;').replace(/>/g, '&gt;');
						if($(parent_obj).attr('allow_new')!=null){
							return {
								term: term,
								allow_new: 1
								// page_limit: 10,
								// page: page
							};
						}else{
							return {
								term: term
								// page_limit: 10,
								// page: page
							};
						}
					},
					results: function (data, page) {
						return {
							// more: (page * 10) < data.total,
							results: $.map(data, function (item) {
								return {
									id: item.id,
									text: item.label,
									value: item.value,
									desc: item.desc
								}
							})
						};
					}
				},
				/*
				initSelection: function (e, callback) {
					if( e.val() != '' ){
						if( $(parent_obj).attr('allow_new')!=null ){
							v_value = { id: (e.val()), allow_new: 1 };
						}else{
							v_value = { id: (e.val()) };
						}
						return $.ajax({
							type: 'POST',
							url: $(parent_obj).attr('ajax_url') ? $(parent_obj).attr('ajax_url') : "#",
							dataType: 'json',
							data: v_value,
							success: function(data){
								if(data.length == 0 && $(parent_obj).attr('allow_new')!=null){
									callback({id: e.val(), text: e.val(), value:e.val()});	
								}else{
									callback(data[0]);
								}
							},
						});
					}
				},
				*/
				createSearchChoice:function(term, data) {
					//== allow custom value
					if( $(parent_obj).attr('allow_new')!=null ){
						if ( $(data).filter( function() {
							return this.text.localeCompare(term)===0;
						}).length===0) {
							return {id:term, text:term, value: term};
						}
					}
				},
			}).on('change', function(e){
				var fn = window[$(this).attr('ajax_callback')];
				if( typeof(fn) === 'function'){
					fn( e.val, e.added.value);
				}
			}).on('select2-loaded', function(e){
			}).on('select2-focus', function(e){
			}).on('select2-selecting', function(e){
			});
			//== to set default data
			if(p_data != null && p_data != ''){
				$(this).select2("data", JSON.parse(p_data) );
			}
		}
	});
	
}
$(document).ready(function(){
	init_jquery_select2();
});	

<?php 
/*
 * To enable Select2 input
 *
 * @param p_obj Object/ID to be passed in
 */
?>
function select2_enable(p_obj){
	if(typeof(p_obj) === 'object'){
		$(p_obj).select2("enable",true);
	}else{
		$('#'+p_obj).select2("enable",true);
	}
}
<?php 
/*
 * To disable Select2 input
 *
 * @param p_obj Object/ID to be passed in
 */
?>
function select2_disable(p_obj){
	if(typeof(p_obj) === 'object'){
		$(p_obj).select2("enable",false);
	}else{
		$('#'+p_obj).select2("enable",false);
	}
}
<?php 
/*
 * To get Select2 input
 *
 * @param p_obj Object/ID to be passed in
 */
?>
function select2_get(p_obj){
	if(typeof(p_obj) === 'object'){
		return $(p_obj).select2("data");
	}else{
		return $('#'+p_obj).select2("data");
	}
}
<?php 
/*
 * To set Select2 input
 *
 * @param p_obj Object/ID to be passed in
 */
?>
function select2_set(p_obj, p_value){
	if(typeof(p_obj) === 'object'){
		return $(p_obj).select2("val", p_value);
	}else{
		return $('#'+p_obj).select2("val", p_value);
	}
}
</script>