/*
 * Copyright (C) 2017 (Eric Kon Yin Liang)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
function mobile(config){

	this.config = config;
	this.getConfigInfo = mGetConfigInfo;

	this.hybridClient = mHybridClient;
	
	
	
	this.openPageJSONBuilder = mOpenPageJSONBuilder;
	this.toastMessageJSONBuilder = mToastMessageJSONBuilder;
	this.popUpDialogJSONBuilder = mPopUpDialogJSONBuilder;
	this.systemUpdateJSONBuilder = mSystemUpdateJSONBuilder;
}

function mGetConfigInfo() {

	return "Configuration Info: "
			+ "\nApplication Name : " + this.config.application_name
			+ "\nDevice Type : " + this.config.device_type
			+ "\nDevice Version : "	+ this.config.device_version
			+ "\nLanguage : " + this.config.language;
}

function mJSONBuilder(keyName, obj){

	var jsonArray = {};
	item = {}
	Object.keys(obj).map(function(key, index) {
		var value = obj[key];
        item [key] = value;
	});
	
	jsonArray[keyName] = item;
	json = JSON.stringify(jsonArray);
	

	JSON.stringify(json);
	return json;
}

function mHybridClient(str){

	if(this.config.device_type.toUpperCase() == "ANDROID"){
		Android.callBack(str);
	}
	else if(this.config.device_type.toUpperCase() == "IOS"){
		window.location = "ios://"+str;
	}
	
	return;
}







/**
 * JSON Builder for open page in mobile (native)
 *
 * @param  obj  JSON string (OPENPAGE as default key)
 * @return      as string
 */
function mOpenPageJSONBuilder(obj){

	return mJSONBuilder("OPENPAGE", obj);
}



/**
 * JSON builder for show message in Android only
 *
 * @param  obj  JSON string  (TOASTMESSAGE as default key)
 * @return      as string
 */
function mToastMessageJSONBuilder(obj){

	return mJSONBuilder("TOASTMESSAGE", obj);
}


/**
 * JSON builder for show dialog in Android only
 *
 * @param  obj  JSON string  (POPUPDIALOG as default key)
 * @return      as string
 */
function mPopUpDialogJSONBuilder(obj){

	return mJSONBuilder("POPUPDIALOG", obj);
}



/**
 * JSON builder for update application
 *
 * @param  obj  JSON string  (SYSTEMUPDATE as default key)
 * @return      as string
 */
function mSystemUpdateJSONBuilder(obj){

	return mJSONBuilder("SYSTEMUPDATE", obj);
}



