/*
 * promptuMenu - jQuery Plugin
 * https://github.com/natrixnatrix89/promptu-menu
 *
 * Copyright (c) 2012 Janis Zarzeckis (http://natrixnatrix89.net)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 */
(function( $ ) {
	$.fn.promptumenu = function(options) {
		var settings = $.extend({
			'columns': 3,
			'rows': 4,
			'direction': 'horizontal',
			'width': 'auto',
			'height': 'auto',
			'duration': 500,
			'pages': true,
			'inertia': 200,
			'current_page': 1,
			'cancelDownTimer': 0
		}, options);
				
		return this.each(function(){
			
			var $this = $(this);
			var properties;
			var blnCancelTimer=false;
			
			var cursor = {
				x:0,
				y:1,
				page:1
			};
			var cells = {
				'width': settings.width,
				'height': settings.height,
				'pages': 1,
				'current_page': settings.current_page
			};
			
			properties = {
				'width': (settings.width == 'auto') ? $this.width() : settings.width,
				'height': (settings.height == 'auto') ? $this.height() : settings.height,
				'padding': 0,
				'overflow': 'hidden'
			};
			
			
			// $this.children('ul').children('li').find('a').addClass('_disabled');
			
			$this.children('ul').children('li').find('a').click(function (e) {
			  e.preventDefault();
			  // console.log($(this).hasClass('disabled'));  
			  //console.log($(this).attr("id") + " " + $(this).hasClass('_disabled'));  
			  if ($(this).hasClass('_disabled')){
				// alert("test123");
				// console.log("return false");
				return false; // Do something else in here if required
			  }else{
				window.location.href = $(this).attr('href');
			  }
			});
			
			var _cnt=0;
			$this.children('ul').children('li').each(function(){
				if ($(this).css('display')!="none"){
					_cnt++;
				}
			});
			
			// console.log(_cnt + " " + $this.children('ul').children('li').length);
					
			var methods = {
				go_to: function(index, easing, webkit){
					if (easing === undefined){
						easing = 'swing';
					}

					var anim, anim_css;
					anim = {'margin-left': (index - 1) * properties.width * (-1)};
					
					$this.animate(anim, settings.duration, easing, function(){
						if (document.getElementById("chkOrder").checked==false && document.getElementById("chkHideShow").checked==false){
							$this.find('a').removeClass('_disabled');
							// console.log("remove class");
						}
					});
					
					//console.log(index);
					$this.parent('div.example_parent').find('.promptumenu_nav a.active').removeClass('active');
					$this.parent('div.example_parent').find('.promptumenu_nav a:nth-child(' + (index) + ')').addClass('active');
					cells.current_page = index;
					
				},
				next_page: function(){
					methods.go_to(cells.current_page + 1);
				},
				prev_page: function(){
					methods.go_to(cells.current_page - 1);
				}
			};
			
			
			$this.go=function(){
				methods.go_to(2);
			}				
			
			if ($('.promptumenu_nav').length > 0){
				$('.promptumenu_nav').remove();
			}
				
			//and append the navigation buttons for each page
			if(settings.total_page > 1 && settings.pages == true){
				var page_links = '<a class="active">Page 1</a>';
				for(i = 2; i <= settings.total_page; i++){
					page_links = page_links + '<a>Page ' + i + '</a>';
				}
								
				$this.parent('div.example_parent').append('<div class="promptumenu_nav">' + page_links + '</div>');
									
				//bind the nav buttons to navigate to the specific page
				
				// console.log("start index = " + settings.current_page);
				$this.parent('div.example_parent').find('.promptumenu_nav a.active').removeClass('active');
				$this.parent('div.example_parent').find('.promptumenu_nav a:nth-child(' + (settings.current_page) + ')').addClass('active');
				
				// console.log("test == " + settings.current_page);
				$this.parent('div.example_parent').find('.promptumenu_nav a').bind('click.promptumenu', function(){
					methods.go_to($(this).index() + 1);
					// methods.go_to(settings.current_page);
				});
				
				var _numWidth = (15 * settings.total_page *-1)/2;
				$('.promptumenu_nav').css('margin-left', _numWidth);
				
			}
			
		
			//Binding all the drag movements
			$this.bind('mousedown.promptumenu', function(mdown){
				
				mdown.preventDefault();
				
				$this.stop(true, false);
				blnCancelTimer=true;
				
				var init_pos = $this.position();
				var click = {
					'x': mdown.pageX,
					'y': mdown.pageY
				};
				var delta = {
					'x': 0,
					'y': 0
				};
				var mmove_event = new Array();
				
				//bind the mousemove to moving the list
				$(document).bind('mousemove.promptumenu', function(mmove){
					mmove.preventDefault();
					var date = new Date();
					var this_event = {
						'time': date.getTime(),
						'x': mmove.pageX,
						'y': mmove.pageY
					};
					
					if (cancelDownTimer!=0 && blnCancelTimer==true){
						// console.log($('.example_parent').position())
						cancelDownTimer();
						blnCancelTimer=false;
					}
					
					//I want to get the average of the last 6 mousemove events before mouseup
					while(mmove_event.length > 4){
						mmove_event.shift();
					}
					
					
					var tmp = $('.example_parent').position();
					
					//console.log(cells.current_page);
					delta.x = mmove.pageX - (click.x + (cells.current_page-1)*settings.width);
					$this.css('margin-left', init_pos.left + delta.x - tmp.left);
					//$this.css('-webkit-transform', 'translate3d(' + (init_pos.left + delta.x) + 'px, 0, 0)');

					$this.find('a').addClass('_disabled');
					mmove_event.push(this_event);
				});
				
				//bind the mouseup to unbinding and animating to the appropriate page
				$(document).bind('mouseup.promptumenu', function(mup){
					mup.preventDefault();
					blnCancelTimer=false;
					$(document).unbind('.promptumenu');
					// alert("test");
					var date = new Date();
					
					var delta_start = mmove_event[0];
					if (delta_start != undefined){
						var delta_end = {
							'time': date.getTime(),
							'x': mup.pageX,
							'y': mup.pageY
						};
						var event_delta = {
							'time': (delta_end.time - delta_start.time),
							'x': (delta_end.x - delta_start.x),
							'y': (delta_end.y - delta_start.y)
						};
						var speed = {
							'x': event_delta.x/event_delta.time,
							'y': event_delta.y/event_delta.time
						};
						/*console.log(mmove_event);
						console.log('The time delta is: ' + (delta_end.time - delta_start.time));
						console.log('The y_speed was: ' + (event_delta.y/event_delta.time));*/
						
						//And now we can animate the list with the appropriate distance and speed
						var pos = init_pos.left + delta.x + speed.x * settings.inertia;
						//check if the user hasn't dragged over the end..
						//console.log(properties.width + " " + cells.pages);
													
						if(pos < ((-1) * properties.width * (settings.total_page - 1))){
							pos = (-1) * properties.width * (settings.total_page - 1);
						} else if(pos > 0){
							pos = 0;
						}
						
						//if the pages are being displayed, we want to snap to the specific page
						if(settings.pages){
							var snap_to_page = Math.round((- pos) / properties.width);
							methods.go_to(snap_to_page + 1, 'inertia');
						} else {
							$this.animate({
								'margin-left': pos
							}, Math.abs(speed.x * settings.inertia), 'inertia');
						}
						
						//$this.children('ul li').find('a').addClass('_disabled');
						$this.find('a').addClass('_disabled');
						$this.find('a').css('cursor', 'pointer'); 
						//console.log($this.find('a'));
					}
				});
				
			});
			
		});
	}
})( jQuery );
	
//Easing for inertia when dragging
jQuery.extend(jQuery.easing, {
	inertia: function (x, t, b, c, d) {
		return c*((t=t/d-1)*t*t + 1) + b;
	}
});
