<?php
/* 
 * Credit & References:
 * https://css-tricks.com/responsive-data-tables/
 * https://bootsnipp.com/snippets/featured/no-more-tables-respsonsive-table
 */

$v_max_screen_width = isset($v_reponsive_dt['max_screen_width'])?$v_reponsive_dt['max_screen_width']:'800px';
$v_tbl_id = isset($v_reponsive_dt['table_id'])?$v_reponsive_dt['table_id']:'tbl_responsive';
$v_td_style = isset($v_reponsive_dt['td_style'])?$v_reponsive_dt['td_style']:'';
$v_td_before_style = isset($v_reponsive_dt['td_before_style'])?$v_reponsive_dt['td_before_style']:'';
?>
<style>
#<?php echo $v_tbl_id; ?> td .action_icon_desc { display: none; }

@media only screen and (max-width: <?php echo $v_max_screen_width; ?>) {
    
    /* Force table to not be like tables anymore */
	#<?php echo $v_tbl_id; ?>, 
	#<?php echo $v_tbl_id; ?> thead, 
	#<?php echo $v_tbl_id; ?> tbody, 
	#<?php echo $v_tbl_id; ?> th, 
	#<?php echo $v_tbl_id; ?> td, 
	#<?php echo $v_tbl_id; ?> tr { 
		display: block; 
	}
 
	/* Hide table headers (but not display: none;, for accessibility) */
	#<?php echo $v_tbl_id; ?> thead tr { 
		position: absolute;
		top: -9999px;
		left: -9999px;
	}
 
	#<?php echo $v_tbl_id; ?> tr { border: 1px solid #ccc; }
 
	#<?php echo $v_tbl_id; ?> td { 
		<?php
		if($v_td_style!=''){
			echo $v_td_style;
		}else{
		?>
		/* Behave  like a "row" */
		border: none;
		border-bottom: 1px solid #dbdbdb; 
		position: relative;
		padding-left: 40%; 
		white-space: normal;
		text-align:left;
		<?php
		}
		?>
	}
 
	#<?php echo $v_tbl_id; ?> td:before { 
		<?php
		if($v_td_before_style!=''){
			echo $v_td_before_style;
		}else{
		?>
		/* Now like a table header */
		position: absolute;
		/* Top/left values mimic padding */
		top: 6px;
		left: 6px;
		width: 20%; 
		padding-right: 0px; 
		white-space: nowrap;
		text-align:left;
		font-weight: bold;
		<?php
		}
		?>
	}
 
	/*
	Label the data
	*/
	#<?php echo $v_tbl_id; ?> td:before { content: attr(data-title); }

	#<?php echo $v_tbl_id; ?> td .action_icon { display: none; }
	#<?php echo $v_tbl_id; ?> td .action_icon_desc { display: inline; }
}
</style>