<?php

require_once('../config/lang/eng.php');
require_once('../tcpdf.php');

// create new PDF document
$pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

$pdf->SetProtection(array());

// set document information
$pdf->SetCreator(PDF_CREATOR);
$pdf->SetAuthor('Nicola Asuni');
$pdf->SetTitle('TCPDF Example 016');
$pdf->SetSubject('TCPDF Tutorial');
$pdf->SetKeywords('TCPDF, PDF, example, test, guide');

// set default header data
$pdf->SetHeaderData('', '', '', 'this is the string');

// set header and footer fonts
$pdf->setHeaderFont(Array('helvetica', '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(Array('helvetica', '', PDF_FONT_SIZE_DATA));

//set margins
$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

//set auto page breaks
$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

//set image scale factor
$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

//set some language-dependent strings
$pdf->setLanguageArray($l);

// ---------------------------------------------------------

// set font
$pdf->SetFont('times', '', 10);

// add a page
$pdf->AddPage();

/*
You can use an external class to automatically hyphens the text by adding the SHY characters;

Unicode Data for SHY:
	Name : SOFT HYPHEN, commonly abbreviated as SHY
	HTML Entity (decimal): &#173;
	HTML Entity (hex): &#xad;
	HTML Entity (named): &shy;
	How to type in Microsoft Windows: [Alt +00AD] or [Alt 0173]
	UTF-8 (hex): 0xC2 0xAD (c2ad)
*/

// html text with soft hyphens (&shy;)

$pdfFilePath = 'http://10.18.4.16/apps/highcourt/poc/modules/highcourt_cms/components/2_case/tcpdf/php-setup.pdf';
$data = "<table border=1><tr><td colspan=2>this is colspan</td></tr><tr><td>this is 1</td><td>this is 2</td></tr>
         <tr><td rowspan=2>this is 3</td><td><div align=left>this is 4</div></td></tr><tr><td>this is 5</td></tr></table>";
$data2 = "<table border=1><tr><td height=90px><div align=center valign=center>this is content</div></td></tr></table>";

// print a cell
$pdf->writeHTML($data, true, 0, true, 0,'C');
$pdf->writeHTML($data2, true, 0, true, 0);
//$html, $ln=true, $fill=false, $reseth=false, $cell=false, $align=''

// ---------------------------------------------------------

//Close and output PDF document
$pdf->Output('example_047.pdf', "I", "I");

//============================================================+
// END OF FILE
//============================================================+
?>
